--------------------------------------------------------------------------------
-- File: keyhandler.lua
-- Version: 1.2
-- Author: ulneiz (Spain)
--------------------------------------------------------------------------------


--------------------------------------------------------------------------------
-- KEYHANDLER
--------------------------------------------------------------------------------
function keyhandler( dlg , key )
    rprint(key)   -- print the value of key to the console
    -- return key -- uncomment to pass key on to Renoise
    local choice_via_shortcut = nil
    -- Insert, Process --------------------------------------------------------------------------------
        if ( key.modifiers == 'alt' and key.name == 'space'  and swi_cl_menu.value ==  2 ) then choice_via_shortcut = 'Insert MGr' insert_01()
    elseif ( key.modifiers == 'alt' and key.name == 'space'  and swi_cl_menu.value ==  3 ) then choice_via_shortcut = 'Insert Gr'  insert_02()
    elseif ( key.modifiers == 'alt' and key.name == 'space'  and swi_cl_menu.value ==  4 and swi_cl_sgrmenu.value == 1) then choice_via_shortcut = 'Insert SGr' insert_03()
    elseif ( key.modifiers == 'alt' and key.name == 'space'  and swi_cl_menu.value ==  4 and swi_cl_sgrmenu.value == 2) then choice_via_shortcut = 'Insert Oct' insert_oct()
    elseif ( key.modifiers == 'alt' and key.name == 'space'  and swi_cl_menu.value ==  5 ) then choice_via_shortcut = 'Insert Tr'  insert_04()
  ---
    elseif ( key.modifiers == 'alt' and key.name == 'space'  and swi_cl_smenu.value == 1 ) then choice_via_shortcut = 'Insert Comb. MGr' insert_05()
    elseif ( key.modifiers == 'alt' and key.name == 'space'  and swi_cl_smenu.value == 2 ) then choice_via_shortcut = 'Insert Comb. Gr'  insert_06()
    elseif ( key.modifiers == 'alt' and key.name == 'space'  and swi_cl_smenu.value == 3 ) then choice_via_shortcut = 'Insert Comb. SGr' insert_07()
    elseif ( key.modifiers == 'alt' and key.name == 'space'  and swi_cl_smenu.value == 4 ) then choice_via_shortcut = 'Insert Comb. Tr'  insert_08()
  ---
  --elseif ( key.modifiers == 'alt' and key.name == 'return' and swi_cl_tmenu.value == 1 ) then choice_via_shortcut = 'Process Tool 01'  process_01()
    elseif ( key.modifiers == 'alt' and key.name == 'return' and swi_cl_tmenu.value == 2 ) then choice_via_shortcut = 'Process Tool 02'  process_02()
  --elseif ( key.modifiers == 'alt' and key.name == 'return' and swi_cl_tmenu.value == 3 ) then choice_via_shortcut = 'Process Tool 03'  process_03()
  --elseif ( key.modifiers == 'alt' and key.name == 'return' and swi_cl_tmenu.value == 4 ) then choice_via_shortcut = 'Process Tool 04'  process_04()
  --elseif ( key.modifiers == 'alt' and key.name == 'return' and swi_cl_tmenu.value == 5 ) then choice_via_shortcut = 'Process Tool 05'  process_05()
  --elseif ( key.modifiers == 'alt' and key.name == 'return' and swi_cl_tmenu.value == 6 ) then choice_via_shortcut = 'Process Tool 06'  process_06()
  --elseif ( key.modifiers == 'alt' and key.name == 'return' and swi_cl_tmenu.value == 7 ) then choice_via_shortcut = 'Process Tool 07'  process_07()
  --elseif ( key.modifiers == 'alt' and key.name == 'return' and swi_cl_tmenu.value == 8 ) then choice_via_shortcut = 'Process Tool 08'  process_08()
  --elseif ( key.modifiers == 'alt' and key.name == 'return' and swi_cl_tmenu.value == 9 ) then choice_via_shortcut = 'Process Tool 09'  process_09()
  --elseif ( key.modifiers == 'alt' and key.name == 'return' and swi_cl_tmenu.value == 10) then choice_via_shortcut = 'Process Tool 10'  process_10()
    -- Switches ------------------------------------------------------------------------------
    elseif ( key.name == 'f1' ) then choice_via_shortcut = 'MGr'  vb.views[ 'main_switch' ].value = 1 
    elseif ( key.name == 'f2' ) then choice_via_shortcut = 'Gr'   vb.views[ 'main_switch' ].value = 2
    elseif ( key.name == 'f3' ) then choice_via_shortcut = 'SGr'  vb.views[ 'main_switch' ].value = 3 vb.views[ 'subgroup_switch' ].value = 1
    elseif ( key.modifiers == 'shift' and key.name == 'f3' ) then choice_via_shortcut = 'Oct' vb.views[ 'main_switch' ].value = 3 vb.views[ 'subgroup_switch' ].value = 2
    elseif ( key.name == 'f4' ) then choice_via_shortcut = 'Tr'   vb.views[ 'main_switch' ].value = 4
    elseif ( key.name == 'f5' ) then choice_via_shortcut = 'CMGr' vb.views[ 'main_switch' ].value = 5  vb.views[ 'submain_switch' ].value = 1
    elseif ( key.name == 'f6' ) then choice_via_shortcut = 'CGr'  vb.views[ 'main_switch' ].value = 5  vb.views[ 'submain_switch' ].value = 2
    elseif ( key.name == 'f7' ) then choice_via_shortcut = 'CSGr' vb.views[ 'main_switch' ].value = 5  vb.views[ 'submain_switch' ].value = 3
    elseif ( key.name == 'f8' ) then choice_via_shortcut = 'CTr'  vb.views[ 'main_switch' ].value = 5  vb.views[ 'submain_switch' ].value = 4
    -- NavTracks, Exit, Wipe & Del -----------------------------------------------------------------
    elseif ( key.modifiers == 'control' and key.name == 'f9' )  then choice_via_shortcut = 'Swap Selected Track to Left' navt_swap_left()
    elseif ( key.name == 'f9'  ) then choice_via_shortcut = 'First Track' navt_first()
    elseif ( key.modifiers == 'control' and key.name == 'f10' )  then choice_via_shortcut = 'Previous Track x 2' navt_01()
    elseif ( key.name == 'f10' ) then choice_via_shortcut = 'Previous Track' navt_02()
    elseif ( key.modifiers == 'control' and key.name == 'f11' )  then choice_via_shortcut = 'Next Track x 2' navt_03()
    elseif ( key.name == 'f11' ) then choice_via_shortcut = 'Next Track' navt_04()
    elseif ( key.modifiers == 'control' and key.name == 'f12' )  then choice_via_shortcut = 'Swap Selected Track/Main Group to Right' navt_swap_right()
    elseif ( key.name == 'f12' ) then choice_via_shortcut = 'Last Track' navt_last()
    elseif ( key.name == 'esc' ) then choice_via_shortcut = 'Edit Mode' wmp_fn_bt_fcs()  -- (key.name == 'esc' or key.name == 'e') -- ...or 'e'
    elseif ( key.name == 'ç' )   then choice_via_shortcut = 'Active/Off Track/Group' navt_on_off()
    elseif ( key.modifiers == 'shift + control' and key.name == 'k' ) then choice_via_shortcut = 'Collapse/Expand Track/Group' navt_coll_gr()
    elseif ( key.modifiers == 'control' and key.name == 'z' ) then choice_via_shortcut = 'Undo' navt_undo()
    elseif ( key.modifiers == 'control' and key.name == 'y' ) then choice_via_shortcut = 'Undo' navt_redo()
    elseif ( key.modifiers == 'shift + control' and key.name == 'del' ) then choice_via_shortcut = 'Delelte' navt_rem()
    elseif ( key.modifiers == 'control' and key.name == 'del' ) then choice_via_shortcut = 'Delelte' navt_del()
    -- UP Selector -----------------------------------------------------------------
    elseif ( key.modifiers == 'control' and key.name == 'home' )  then choice_via_shortcut = 'Advanced Tools' vb.views[ 'SWI_UP_SELECT' ].value = 4 
    elseif ( key.modifiers == 'control' and key.name == 'end' )   then choice_via_shortcut = 'Close Window'   vb.views[ 'SWI_UP_SELECT' ].value = 1
    elseif ( key.modifiers == 'control' and key.name == 'prior' ) then choice_via_shortcut = 'Key Commands'   vb.views[ 'SWI_UP_SELECT' ].value = 2
    elseif ( key.modifiers == 'control' and key.name == 'next' )  then choice_via_shortcut = 'About'          vb.views[ 'SWI_UP_SELECT' ].value = 3
    -- Advanced Tools Selector -----------------------------------------------------
    elseif ( key.modifiers == 'control' and key.name == '1' ) then choice_via_shortcut = 'Tool 01' vb.views[ 'SWI_UP_SELECT' ].value = 4 vb.views[ 'SWI_AT_SELECT' ].value = 1
    elseif ( key.modifiers == 'control' and key.name == '2' ) then choice_via_shortcut = 'Tool 02' vb.views[ 'SWI_UP_SELECT' ].value = 4 vb.views[ 'SWI_AT_SELECT' ].value = 2
    elseif ( key.modifiers == 'control' and key.name == '3' ) then choice_via_shortcut = 'Tool 03' vb.views[ 'SWI_UP_SELECT' ].value = 4 vb.views[ 'SWI_AT_SELECT' ].value = 3
    elseif ( key.modifiers == 'control' and key.name == '4' ) then choice_via_shortcut = 'Tool 04' vb.views[ 'SWI_UP_SELECT' ].value = 4 vb.views[ 'SWI_AT_SELECT' ].value = 4
    elseif ( key.modifiers == 'control' and key.name == '5' ) then choice_via_shortcut = 'Tool 05' vb.views[ 'SWI_UP_SELECT' ].value = 4 vb.views[ 'SWI_AT_SELECT' ].value = 5
    elseif ( key.modifiers == 'control' and key.name == '6' ) then choice_via_shortcut = 'Tool 06' vb.views[ 'SWI_UP_SELECT' ].value = 4 vb.views[ 'SWI_AT_SELECT' ].value = 6
    elseif ( key.modifiers == 'control' and key.name == '7' ) then choice_via_shortcut = 'Tool 07' vb.views[ 'SWI_UP_SELECT' ].value = 4 vb.views[ 'SWI_AT_SELECT' ].value = 7 vb.views[ 'main_switch' ].value = 1
    elseif ( key.modifiers == 'control' and key.name == '8' ) then choice_via_shortcut = 'Tool 08' vb.views[ 'SWI_UP_SELECT' ].value = 4 vb.views[ 'SWI_AT_SELECT' ].value = 8
    elseif ( key.modifiers == 'control' and key.name == '9' ) then choice_via_shortcut = 'Tool 09' vb.views[ 'SWI_UP_SELECT' ].value = 4 vb.views[ 'SWI_AT_SELECT' ].value = 9
    elseif ( key.modifiers == 'control' and key.name == '0' ) then choice_via_shortcut = 'Tool 10' vb.views[ 'SWI_UP_SELECT' ].value = 4 vb.views[ 'SWI_AT_SELECT' ].value = 10
    -- DW Selector -----------------------------------------------------------------
    elseif ( key.modifiers == 'control' and key.name == "'" ) then choice_via_shortcut = 'Swow'  vb.views[ 'SWI_UP_SELECT' ].value = 4 vb.views[ 'SWI_DW_SELECT' ].value = 1
    elseif ( key.modifiers == 'control' and key.name == "¡" ) then choice_via_shortcut = 'Close' vb.views[ 'SWI_UP_SELECT' ].value = 4 vb.views[ 'SWI_DW_SELECT' ].value = 2
    end
    ----
 --[[
 
 
    local vb_switch = vb.views[ 'mgr_switch_cl' ]
    if ( key.name == 'right' and swi_cl_menu.value == 2 ) then
      vb_switch.value = math.min( #vb_switch.items , vb_switch.value + 1 )
    elseif ( key.name == 'left' and swi_cl_menu.value == 2 ) then
      vb_switch.value = math.max( 1 , vb_switch.value - 1 )
    end
    local vb_popup = vb.views[ 'mgr_popup' ]
    if ( key.name == 'down' and swi_cl_menu.value == 2 ) then
      vb_popup.value = math.min(#vb_popup.items,vb_popup.value + 1 )
    elseif ( key.name == 'up' and swi_cl_menu.value == 2 ) then
      vb_popup.value = math.max( 1 , vb_popup.value - 1 )
    end
    ----
    local vb_switch = vb.views[ 'gr_switch_cl' ]
    if ( key.name == 'right' and swi_cl_menu.value == 3) then
      vb_switch.value = math.min( #vb_switch.items , vb_switch.value + 1 )
    elseif ( key.name == 'left' and swi_cl_menu.value == 3 ) then
      vb_switch.value = math.max( 1 , vb_switch.value - 1 )
    end
    local vb_popup = vb.views[ 'gr_popup' ]
    if ( key.name == 'down' and swi_cl_menu.value == 3 ) then
      vb_popup.value = math.min( #vb_popup.items,vb_popup.value + 1 )
    elseif ( key.name == 'up' and swi_cl_menu.value == 3 ) then
      vb_popup.value = math.max( 1 , vb_popup.value - 1 )
    end
    ----
    local vb_switch = vb.views[ 'sgr_switch_cl' ]
    if ( key.name == 'right' and swi_cl_menu.value == 4 and swi_cl_sgrmenu.value == 1 ) then
      vb_switch.value = math.min( #vb_switch.items , vb_switch.value + 1 )
    elseif ( key.name == 'left' and swi_cl_menu.value == 4 and swi_cl_sgrmenu.value == 1 ) then
      vb_switch.value = math.max( 1 , vb_switch.value - 1 )
    end
    local vb_popup = vb.views[ 'sgr_popup' ]
    if ( key.name == 'down' and swi_cl_menu.value == 4 and swi_cl_sgrmenu.value == 1 ) then
      vb_popup.value = math.min( #vb_popup.items , vb_popup.value + 1 )
    elseif ( key.name == 'up' and swi_cl_menu.value == 4 and swi_cl_sgrmenu.value == 1 ) then
      vb_popup.value = math.max( 1 , vb_popup.value - 1 )
    end
    ----
    local vb_switch = vb.views[ 'oct_switch_cl' ]
    if ( key.name == 'right' and swi_cl_menu.value == 4 and swi_cl_sgrmenu.value == 2 ) then
      vb_switch.value = math.min( #vb_switch.items , vb_switch.value + 1 )
    elseif ( key.name == 'left' and swi_cl_menu.value == 4 and swi_cl_sgrmenu.value == 2 ) then
      vb_switch.value = math.max( 1 , vb_switch.value - 1 )
    end
    local vb_popup = vb.views[ 'oct_popup' ]
    if ( key.name == 'down' and swi_cl_menu.value == 4 and swi_cl_sgrmenu.value == 2 ) then
      vb_popup.value = math.min( #vb_popup.items , vb_popup.value + 1 )
    elseif ( key.name == 'up' and swi_cl_menu.value == 4 and swi_cl_sgrmenu.value == 2 ) then
      vb_popup.value = math.max( 1 , vb_popup.value - 1 )
    end
    ----
    local vb_switch = vb.views[ 'tr_switch_cl' ]
    if ( key.name == 'right' and swi_cl_menu.value == 5 ) then
      vb_switch.value = math.min( #vb_switch.items , vb_switch.value + 1 )
    elseif ( key.name == 'left' and swi_cl_menu.value == 5 ) then
      vb_switch.value = math.max( 1 , vb_switch.value - 1 )
    end
    local vb_popup = vb.views[ 'tr_popup' ]
    if ( key.name == 'down' and swi_cl_menu.value == 5 ) then
      vb_popup.value = math.min( #vb_popup.items , vb_popup.value + 1 )
    elseif ( key.name == 'up' and swi_cl_menu.value == 5 ) then
      vb_popup.value = math.max( 1 , vb_popup.value - 1 )
    end

    ----

    local vb_popup = vb.views[ 'cmgr_popup' ]
    if ( key.name == 'down' and swi_cl_smenu.value == 1 ) then
      vb_popup.value = math.min( #vb_popup.items , vb_popup.value + 1 )
    elseif ( key.name == 'up' and swi_cl_smenu.value == 1 ) then
      vb_popup.value = math.max( 1 , vb_popup.value - 1 )
    end
    ----
    local vb_popup = vb.views[ 'cgr_popup' ]
    if ( key.name == 'down' and swi_cl_smenu.value == 2 ) then
      vb_popup.value = math.min( #vb_popup.items , vb_popup.value + 1 )
    elseif ( key.name == 'up' and swi_cl_smenu.value == 2 ) then
      vb_popup.value = math.max( 1 , vb_popup.value - 1 )
    end
    ----
    local vb_popup = vb.views[ 'csgr_popup' ]
    if ( key.name == 'down' and swi_cl_smenu.value == 3 ) then
      vb_popup.value = math.min( #vb_popup.items , vb_popup.value + 1 )
    elseif ( key.name == 'up' and swi_cl_smenu.value == 3 ) then
      vb_popup.value = math.max( 1 , vb_popup.value - 1 )
    end
    ----
    local vb_popup = vb.views[ 'ctr_popup' ]
    if ( key.name == 'down' and swi_cl_smenu.value == 4 ) then
      vb_popup.value = math.min( #vb_popup.items,vb_popup.value + 1 )
    elseif ( key.name == 'up' and swi_cl_smenu.value == 4 ) then
      vb_popup.value = math.max( 1 , vb_popup.value - 1 )
    end
    ----
    local vb_switch = vb.views[ 'tls_switch_cl' ]
    if ( key.name == 'right' and swi_cl_hmenu.value == 4 and swi_cl_tmenu.value == 2 ) then
      vb_switch.value = math.min( #vb_switch.items , vb_switch.value + 1 )
    elseif ( key.name == 'left' and swi_cl_hmenu.value == 4 and swi_cl_tmenu.value == 2 ) then
      vb_switch.value = math.max( 1 , vb_switch.value - 1)
    end
]]

end
