--------------------------------------------------------------------------------
-- Module Tool: Tool_03.lua
-- Name: DCSP: Device Chain Specific Presets
-- Version: 1.0b
-- Author: ulneiz (Spain)
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- SECTION 01
--------------------------------------------------------------------------------

class 'DCSP' --

DCSP.CR = {
  BT_A01 = { 0x00,0x40,0x70 },
  BT_A02 = { 0x00,0x40,0x70 },
  BT_A03 = { 0x00,0x40,0x70 },
  BT_A04 = { 0x00,0x40,0x70 },
  BT_A05 = { 0x00,0x40,0x70 },
  BT_A06 = { 0x00,0x40,0x70 },
  BT_A07 = { 0x00,0x40,0x70 },
  BT_A08 = { 0x00,0x40,0x70 },
  BT_A09 = { 0x00,0x40,0x70 },
  BT_A10 = { 0x00,0x40,0x70 },
  BT_DEL = { 0x66,0x00,0x00 }  
}

TX_A01 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 01"} }
TX_A02 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 02"} }
TX_A03 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 03"} }
TX_A04 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 04"} }
TX_A05 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 05"} }
TX_A06 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 06"} }
TX_A07 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 07"} }
TX_A08 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 08"} }
TX_A09 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 09"} }
TX_A10 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 10"} }

TX_A11 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 11"} }
TX_A12 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 12"} }
TX_A13 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 13"} }
TX_A14 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 14"} }
TX_A15 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 15"} }
TX_A16 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 16"} }
TX_A17 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 17"} }
TX_A18 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 18"} }
TX_A19 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 19"} }
TX_A20 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 20"} }

TX_A21 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 21"} }
TX_A22 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 22"} }
TX_A23 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 23"} }
TX_A24 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 24"} }
TX_A25 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 25"} }
TX_A26 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 26"} }
TX_A27 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 27"} }
TX_A28 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 28"} }
TX_A29 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 29"} }
TX_A30 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 30"} }

TX_A31 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 31"} }
TX_A32 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 32"} }
TX_A33 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 33"} }
TX_A34 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 34"} }
TX_A35 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 35"} }
TX_A36 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 36"} }
TX_A37 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 37"} }
TX_A38 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 38"} }
TX_A39 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 39"} }
TX_A40 = vb:horizontal_aligner { mode = 'right', height = 18 , vb:text { text = "Doofer  ➡  Gainer  ➡  Low EQ 10  ➡  Medium EQ 10  ➡  High EQ 10 ..." }, vb:text { font = 'bold', text = "    EQ 30 + Gainer 40"} }

--------------------------------------------------------------------------------
-- LIST AVAILABLE DEVICES: NATIVE EFFECTS
--------------------------------------------------------------------------------
--[[ 

  --terminal>> rprint (renoise.song().selected_track.available_devices)

[00] =>  Audio/Effects/VST/Name

[01] =>  Audio/Effects/Native/Delay
[02] =>  Audio/Effects/Native/Multitap
[03] =>  Audio/Effects/Native/mpReverb 2
[04] =>  Audio/Effects/Native/Reverb
[05] =>  Audio/Effects/Native/Convolver
[06] =>  Audio/Effects/Native/Bus Compressor
[07] =>  Audio/Effects/Native/Compressor
[08] =>  Audio/Effects/Native/Gate 2
[09] =>  Audio/Effects/Native/Maximizer
[10] =>  Audio/Effects/Native/Analog Filter
[11] =>  Audio/Effects/Native/Digital Filter
[12] =>  Audio/Effects/Native/Comb Filter 2
[13] =>  Audio/Effects/Native/EQ 5
[14] =>  Audio/Effects/Native/EQ 10
[15] =>  Audio/Effects/Native/Mixer EQ
[16] =>  Audio/Effects/Native/Chorus 2
[17] =>  Audio/Effects/Native/Flanger 2
[18] =>  Audio/Effects/Native/Phaser 2
[19] =>  Audio/Effects/Native/RingMod 2
[20] =>  Audio/Effects/Native/LofiMat 2
[21] =>  Audio/Effects/Native/Distortion 2
[22] =>  Audio/Effects/Native/Cabinet Simulator
[23] =>  Audio/Effects/Native/Exciter
[24] =>  Audio/Effects/Native/Stereo Expander
[25] =>  Audio/Effects/Native/DC Offset
[26] =>  Audio/Effects/Native/Gainer
[27] =>  Audio/Effects/Native/Repeater
[28] =>  Audio/Effects/Native/Doofer
[29] =>  Audio/Effects/Native/#Line Input
[30] =>  Audio/Effects/Native/#ReWire Input
[31] =>  Audio/Effects/Native/#Send
[32] =>  Audio/Effects/Native/#Multiband Send
[33] =>  Audio/Effects/Native/*Instr. Macros
[34] =>  Audio/Effects/Native/*Instr. Automation
[35] =>  Audio/Effects/Native/*Instr. MIDI Control
[36] =>  Audio/Effects/Native/*Hydra
[37] =>  Audio/Effects/Native/*Meta Mixer
[38] =>  Audio/Effects/Native/*Formula
[39] =>  Audio/Effects/Native/*XY Pad
[40] =>  Audio/Effects/Native/*LFO
[41] =>  Audio/Effects/Native/*Key Tracker
[42] =>  Audio/Effects/Native/*Velocity Tracker
[42] =>  Audio/Effects/Native/*Signal Follower

renoise.song().tracks[]:insert_device_at(device_path, device_index)
renoise.song().tracks[].devices[2].is_active = True/False
renoise.song().tracks[].devices[2].is_maximized = True/False
renoise.song().tracks[].devices[2].display_name = "Name"
renoise.song().tracks[].devices[2].active_preset = 2
renoise.song().tracks[].devices[2].active_preset_data = "<?xml version='1.0'encoding='UTF-8'?><FilterDevicePreset doc_version='2'><DeviceSlot type='Eq5Device'> ... </FilterDevicePreset>"
renoise.song().tracks[].devices[2].presets[]

renoise.app():load_track_device_chain(filename)        -> [boolean]
renoise.app():load_track_device_preset(filename)       -> [boolean]
renoise.app():load_instrument(filename)                -> [boolean]
renoise.app():load_instrument_multi_sample(filename)   -> [boolean]
renoise.app():load_instrument_device_chain(filename)   -> [boolean]
renoise.app():load_instrument_device_preset(filename)  -> [boolean]
renoise.app():load_instrument_modulation_set(filename) -> [boolean]
renoise.app():load_instrument_phrase(filename)         -> [boolean]
renoise.app():load_instrument_sample(filename)         -> [boolean]
renoise.app():load_theme(filename)                     -> [boolean]

]]


--[[

function gainer() --INSERT NATIVE DEVICE CHAIN
  local song = renoise.song()
  local tid = song.selected_track_index
  song:track(tid):insert_device_at("Audio/Effects/Native/Gainer", 2)
  song.tracks[tid].devices[2].is_active = F
  song.tracks[tid].devices[2].display_name = "Backing Gainer"
end
--- ---
function eq_5_low_99()
  local song = renoise.song()
  local tid = song.selected_track_index
  song:track(tid):insert_device_at("Audio/Effects/Native/EQ 5", 2)
  song.tracks[tid].devices[2].is_active = F
  song.tracks[tid].devices[2].display_name = "EQ 5 LOW"
  song.tracks[tid].devices[2].active_preset_data = "<?xml version='1.0' encoding='UTF-8'?><FilterDevicePreset doc_version='2'><DeviceSlot type='Eq5Device'><Frequency0>40</Frequency0><Frequency1>60</Frequency1><Frequency2>80</Frequency2><Frequency3>100</Frequency3><Frequency4>120</Frequency4></DeviceSlot></FilterDevicePreset>"
  --song.tracks[tid].devices[2].active_preset = 3
end

]]

--------------------------------------------------------------------------------
--TRACK DEVICE CHAIN FUNCTIONS
--------------------------------------------------------------------------------
function dcsp_fn_A01() --INSERT PERSONALIZED DEVICE CHAIN (.XRNT)
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A02()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A03()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A04()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A05()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A06()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A07()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A08()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A09()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A10()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A11()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A12()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A13()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A14()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A15()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A16()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A17()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A18()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A19()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A20()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A21()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A22()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A23()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A24()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A25()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A26()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A27()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A28()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A29()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A30()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A31()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A32()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A33()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A34()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A35()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A36()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A37()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A38()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A39()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
function dcsp_fn_A40()
  local app = renoise.app()
  app:load_track_device_chain("xrnt/eq_30_device_chain.xrnt")
end
--- ---
--- ---
function dcsp_fn_bypass( st )
  local st = renoise.song().selected_track
  for i = 2, #st.devices do
    st:device(i).is_active = false
  end
end

function dcsp_fn_all_on( st )
  local st = renoise.song().selected_track
  for i = 2, #st.devices do
    st:device(i).is_active = true
  end
end

function dcsp_fn_show_low_pane( app )
  app = renoise.app()
  if app.window.lower_frame_is_visible == true then
    app.window.lower_frame_is_visible = false
    else
    app.window.lower_frame_is_visible = true
    app.window.active_lower_frame = renoise.ApplicationWindow.LOWER_FRAME_TRACK_DSPS
  end
end
function dcsp_low( app )
  app = renoise.app()
  app.window.lower_frame_is_visible = true
  app.window.active_lower_frame = renoise.ApplicationWindow.LOWER_FRAME_TRACK_DSPS
end
--- ---
--- ---
function dcsp_fn_DEL()
  local song, app = renoise.song(), renoise.app()
  --print(#song.selected_track.devices)
  if ( #song.selected_track.devices > 1 ) then
    song.tracks[song.selected_track_index]:delete_device_at(2)
  else
    app:show_status( "⚠ GT16-Colors DCSP:  does not exist Device Chain!" )
  end
end
--- ---
function dcsp_fn_DEF()
  if vb.views['DCSP_VB_HEIGHT'].value > 0 then
     vb.views['DCSP_VB_HEIGHT'].value = 1
     vb.views['CENTER_COLUMN'].height = 106
     vb.views['CENTER_COLUMN_V1'].height = 72
     vb.views['CENTER_COLUMN_V2'].height = 72
  end
end

function tracks_dev()
  local song = renoise.song()
  local dev = #song.selected_track.devices - 1
  vb.views["dev_index"].text = ( "D:%s" ):format( dev )
end

function dev_tracks()
  renoise.song().selected_track.devices_observable:add_notifier(tracks_dev)
  renoise.song().selected_track_index_observable:add_notifier(tracks_dev)
end
renoise.tool().app_new_document_observable:add_notifier(dev_tracks) -- To initialice New Start Renoise


--------------------------------------------------------------------------------
-- FUNCTION BUTTONS
--------------------------------------------------------------------------------
function dcsp_A01()
  dcsp_fn_A01()  
end

function dcsp_A02()
  dcsp_fn_A02()  
end

function dcsp_A03()
  dcsp_fn_A03()  
end

function dcsp_A04()
  dcsp_fn_A04()  
end

function dcsp_A05()
  dcsp_fn_A05()  
end

function dcsp_A06()
  dcsp_fn_A06()  
end

function dcsp_A07()
  dcsp_fn_A07()  
end

function dcsp_A08()
  dcsp_fn_A08()  
end

function dcsp_A09()
  dcsp_fn_A09()  
end

function dcsp_A10()
  dcsp_fn_A10()  
end

function dcsp_A11()
  dcsp_fn_A11()  
end

function dcsp_A12()
  dcsp_fn_A12()  
end

function dcsp_A13()
  dcsp_fn_A13()  
end

function dcsp_A14()
  dcsp_fn_A14()  
end

function dcsp_A15()
  dcsp_fn_A15()  
end

function dcsp_A16()
  dcsp_fn_A16()  
end

function dcsp_A17()
  dcsp_fn_A17()  
end

function dcsp_A18()
  dcsp_fn_A18()  
end

function dcsp_A19()
  dcsp_fn_A19()  
end

function dcsp_A20()
  dcsp_fn_A20()  
end

function dcsp_A21()
  dcsp_fn_A21()  
end

function dcsp_A22()
  dcsp_fn_A22()  
end

function dcsp_A23()
  dcsp_fn_A23()  
end

function dcsp_A24()
  dcsp_fn_A24()  
end

function dcsp_A25()
  dcsp_fn_A25()  
end

function dcsp_A26()
  dcsp_fn_A26()  
end

function dcsp_A27()
  dcsp_fn_A27()  
end

function dcsp_A28()
  dcsp_fn_A28()  
end

function dcsp_A29()
  dcsp_fn_A29()  
end

function dcsp_A30()
  dcsp_fn_A30()  
end

function dcsp_A31()
  dcsp_fn_A31()  
end

function dcsp_A32()
  dcsp_fn_A32()  
end

function dcsp_A33()
  dcsp_fn_A33()  
end

function dcsp_A34()
  dcsp_fn_A34()  
end

function dcsp_A35()
  dcsp_fn_A35()  
end

function dcsp_A36()
  dcsp_fn_A36()  
end

function dcsp_A37()
  dcsp_fn_A37()  
end

function dcsp_A38()
  dcsp_fn_A38()  
end

function dcsp_A39()
  dcsp_fn_A39()  
end

function dcsp_A40()
  dcsp_fn_A40()  
end

function dcsp_DEL()
  dcsp_fn_DEL()  
end

function dcsp_DEF()
  dcsp_fn_DEF()  
end


DCSP_BT_A01 = vb:button {
  id = 'DCSP_BT_A01',
  tooltip = 'Insert A01',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A01() end
}

DCSP_BT_A02 = vb:button {
  id = 'DCSP_BT_A02',
  tooltip = 'Insert A02',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A02() end
}

DCSP_BT_A03 = vb:button {
  id = 'DCSP_BT_A03',
  tooltip = 'Insert A03',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A03() end
}

DCSP_BT_A04 = vb:button {
  id = 'DCSP_BT_A04',
  tooltip = 'Insert A04',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A04() end
}

DCSP_BT_A05 = vb:button {
  id = 'DCSP_BT_A05',
  tooltip = 'Insert A05',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A05() end
}

DCSP_BT_A06 = vb:button {
  id = 'DCSP_BT_A06',
  tooltip = 'Insert A06',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A06() end
}

DCSP_BT_A07 = vb:button {
  id = 'DCSP_BT_A07',
  tooltip = 'Insert A07',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A07() end
}

DCSP_BT_A08 = vb:button {
  id = 'DCSP_BT_A08',
  tooltip = 'Insert A08',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A08() end
}

DCSP_BT_A09 = vb:button {
  id = 'DCSP_BT_A09',
  tooltip = 'Insert A09',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A09() end
}

DCSP_BT_A10 = vb:button {
  id = 'DCSP_BT_A10',
  tooltip = 'Insert A10',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A10() end
}
DCSP_BT_A11 = vb:button {
  id = 'DCSP_BT_A11',
  tooltip = 'Insert A11',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A11() end
}
DCSP_BT_A12 = vb:button {
  id = 'DCSP_BT_A12',
  tooltip = 'Insert A12',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A12() end
}
DCSP_BT_A13 = vb:button {
  id = 'DCSP_BT_A13',
  tooltip = 'Insert A13',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A13() end
}
DCSP_BT_A14 = vb:button {
  id = 'DCSP_BT_A14',
  tooltip = 'Insert A14',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A14() end
}
DCSP_BT_A15 = vb:button {
  id = 'DCSP_BT_A15',
  tooltip = 'Insert A15',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A15() end
}
DCSP_BT_A16 = vb:button {
  id = 'DCSP_BT_A16',
  tooltip = 'Insert A16',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A16() end
}
DCSP_BT_A17 = vb:button {
  id = 'DCSP_BT_A17',
  tooltip = 'Insert A17',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A17() end
}
DCSP_BT_A18 = vb:button {
  id = 'DCSP_BT_A18',
  tooltip = 'Insert A18',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A18() end
}
DCSP_BT_A19 = vb:button {
  id = 'DCSP_BT_A19',
  tooltip = 'Insert A19',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A19() end
}
DCSP_BT_A20 = vb:button {
  id = 'DCSP_BT_A20',
  tooltip = 'Insert A20',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A20() end
}
DCSP_BT_A21 = vb:button {
  id = 'DCSP_BT_A21',
  tooltip = 'Insert A21',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A21() end
}
DCSP_BT_A22 = vb:button {
  id = 'DCSP_BT_A22',
  tooltip = 'Insert A22',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A22() end
}
DCSP_BT_A23 = vb:button {
  id = 'DCSP_BT_A23',
  tooltip = 'Insert A23',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A23() end
}
DCSP_BT_A24 = vb:button {
  id = 'DCSP_BT_A24',
  tooltip = 'Insert A24',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A24() end
}
DCSP_BT_A25 = vb:button {
  id = 'DCSP_BT_A25',
  tooltip = 'Insert A25',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A25() end
}
DCSP_BT_A26 = vb:button {
  id = 'DCSP_BT_A26',
  tooltip = 'Insert A26',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A26() end
}
DCSP_BT_A27 = vb:button {
  id = 'DCSP_BT_A27',
  tooltip = 'Insert A27',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A27() end
}
DCSP_BT_A28 = vb:button {
  id = 'DCSP_BT_A28',
  tooltip = 'Insert A28',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A28() end
}
DCSP_BT_A29 = vb:button {
  id = 'DCSP_BT_A29',
  tooltip = 'Insert A29',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A29() end
}
DCSP_BT_A30 = vb:button {
  id = 'DCSP_BT_A30',
  tooltip = 'Insert A30',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A30() end
}
DCSP_BT_A31 = vb:button {
  id = 'DCSP_BT_A31',
  tooltip = 'Insert A31',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A31() end
}
DCSP_BT_A32 = vb:button {
  id = 'DCSP_BT_A32',
  tooltip = 'Insert A32',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A32() end
}
DCSP_BT_A33 = vb:button {
  id = 'DCSP_BT_A33',
  tooltip = 'Insert A33',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A33() end
}
DCSP_BT_A34 = vb:button {
  id = 'DCSP_BT_A34',
  tooltip = 'Insert A34',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A34() end
}
DCSP_BT_A35 = vb:button {
  id = 'DCSP_BT_A35',
  tooltip = 'Insert A35',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A35() end
}
DCSP_BT_A36 = vb:button {
  id = 'DCSP_BT_A36',
  tooltip = 'Insert A36',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A36() end
}
DCSP_BT_A37 = vb:button {
  id = 'DCSP_BT_A37',
  tooltip = 'Insert A37',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A37() end
}
DCSP_BT_A38 = vb:button {
  id = 'DCSP_BT_A38',
  tooltip = 'Insert A38',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A38() end
}
DCSP_BT_A39 = vb:button {
  id = 'DCSP_BT_A39',
  tooltip = 'Insert A39',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A39() end
}
DCSP_BT_A40 = vb:button {
  id = 'DCSP_BT_A40',
  tooltip = 'Insert A40',
  bitmap = "icons/lock.bmp",
  text = '+',
  color = DCSP.CR.BT_A01,
  width = 28,
  height = 18,
  notifier = function() dcsp_low() dcsp_A40() end
}
--- ---
DCSP_BT_DEL = vb:button {
  id = 'DCSP_BT_DEL',
  tooltip = 'Delete Track Device Chain (the first).',
  --bitmap = "icons/lock.bmp",
  text = 'DEL\nFX',
  color = DCSP.CR.BT_DEL,
  width = 34,
  height = 58,
  notifier = function()dcsp_DEL() end
}
--- ---
DCSP_CN_DEV = vb:column {
  id = 'DCSP_CN_DEV',
  tooltip = 'Total Number of Device Chain in Track/Group/Master/Send Selected.\nSelect any Track to reactivate!',
  width = 34,
  style = 'panel',
  vb:horizontal_aligner {
    height = 22,
    mode = 'center',
    vb: text {
      font = 'bold',
      align = 'center',
      id = 'dev_index',  -- ID
      text = '000'
    }
  }
}
--- ---
DCSP_VB_HEIGHT = vb:valuebox{
  id = 'DCSP_VB_HEIGHT',
  tooltip = 'Deploy Presets List.',
  min = 1,
  max = 10,
  value = 1,
  width = 50,
  height = 22,
  notifier = function()
    if vb.views['DCSP_VB_HEIGHT'].value == 1 then
       vb.views['CENTER_COLUMN'].height = 106
       vb.views['CENTER_COLUMN_V1'].height = 72
       vb.views['CENTER_COLUMN_V2'].height = 72
    elseif
       vb.views['DCSP_VB_HEIGHT'].value == 2 then
       vb.views['CENTER_COLUMN'].height = 176
       vb.views['CENTER_COLUMN_V1'].height = 144
       vb.views['CENTER_COLUMN_V2'].height = 144
    elseif
       vb.views['DCSP_VB_HEIGHT'].value == 3 then
       vb.views['CENTER_COLUMN'].height = 248
       vb.views['CENTER_COLUMN_V1'].height = 216
       vb.views['CENTER_COLUMN_V2'].height = 216
    elseif
       vb.views['DCSP_VB_HEIGHT'].value == 4 then
       vb.views['CENTER_COLUMN'].height = 320
       vb.views['CENTER_COLUMN_V1'].height = 288
       vb.views['CENTER_COLUMN_V2'].height = 288
    elseif
       vb.views['DCSP_VB_HEIGHT'].value == 5 then
       vb.views['CENTER_COLUMN'].height = 392
       vb.views['CENTER_COLUMN_V1'].height = 360
       vb.views['CENTER_COLUMN_V2'].height = 360
    elseif
       vb.views['DCSP_VB_HEIGHT'].value == 6 then
       vb.views['CENTER_COLUMN'].height = 464
       vb.views['CENTER_COLUMN_V1'].height = 432
       vb.views['CENTER_COLUMN_V2'].height = 432
    elseif
       vb.views['DCSP_VB_HEIGHT'].value == 7 then
       vb.views['CENTER_COLUMN'].height = 536
       vb.views['CENTER_COLUMN_V1'].height = 504
       vb.views['CENTER_COLUMN_V2'].height = 504
    elseif
       vb.views['DCSP_VB_HEIGHT'].value == 8 then
       vb.views['CENTER_COLUMN'].height = 608
       vb.views['CENTER_COLUMN_V1'].height = 576
       vb.views['CENTER_COLUMN_V2'].height = 576
    elseif
       vb.views['DCSP_VB_HEIGHT'].value == 9 then
       vb.views['CENTER_COLUMN'].height = 680
       vb.views['CENTER_COLUMN_V1'].height = 648
       vb.views['CENTER_COLUMN_V2'].height = 648
    elseif
       vb.views['DCSP_VB_HEIGHT'].value == 10 then
       vb.views['CENTER_COLUMN'].height = 760
       vb.views['CENTER_COLUMN_V1'].height = 726
       vb.views['CENTER_COLUMN_V2'].height = 726
    end
  end
}
--- ---
DCSP_BT_DEF = vb:button {
  id = 'DCSP_BT_DEF',
  tooltip = 'Default Deploy [01].',
  color = { 0x00,0x20,0x50 },
  text = 'DF', --bitmap = "icons/lock.bmp",
  width = 30,
  height = 22,
  notifier = function() dcsp_fn_DEF() end
}
--- ---
DCSP_BT_LOW = vb:button {
  id = 'DCSP_BT_LOW',
  tooltip = 'Show/hide low pane DSP Chain.',
  color = { 0x70,0x20,0xB0 },
  bitmap = 'icons/show-dsp-pane-ico.bmp',
  width = 32,
  height = 22,
  notifier = function() dcsp_fn_show_low_pane() end  
}
--- ---
DCSP_BT_ALL_ON = vb:button {
  id = 'DCSP_BT_ALL_ON',
  tooltip = 'Activate all devices in DSP Chain.',
  color = { 0x7F,0x05,0x54 },
  text = 'ALL ON', --bitmap = 'icons/show-dsp-pane-ico.bmp',
  width = 40,
  height = 22,
  notifier = function() dcsp_fn_all_on() end  
}
DCSP_BT_BYPASS = vb:button {
  id = 'DCSP_BT_BYPASS',
  tooltip = 'Deactivate all devices in DSP Chain.',
  color = { 0x7F,0x05,0x54 },
  text = 'BYPASS', --bitmap = 'icons/show-dsp-pane-ico.bmp',
  width = 40,
  height = 22,
  notifier = function() dcsp_fn_bypass() end  
}
--- ---
DCSP_ICO_PRE  = vb:bitmap { bitmap = 'icons/pre-ico.bmp',  mode = 'body_color', width = 12, height = 30, tooltip = 'Pre DSP Chain'  }
DCSP_ICO_POST = vb:bitmap { bitmap = 'icons/post-ico.bmp', mode = 'body_color', width = 12, height = 30, tooltip = 'Post DSP Chain'  }


--------------------------------------------------------------------------------
-- GUI - TOOL DCSP
--------------------------------------------------------------------------------
DCSP =
vb:column {
  id = 'CENTER_COLUMN',
  --- ---
  vb:horizontal_aligner {
    width = 678,
    mode = 'right',
    vb:bitmap {
      bitmap = 'icons/chains-ico.bmp',
      mode = 'body_color',
      height = 22,
    },
    vb:text { font = 'bold', text = 'DCSP: Device Chain Specific Presets', height = 22 },
    vb:text { text = '   v1.0b', height = 22 },
    vb:horizontal_aligner { width = 60 },
    vb:row {
      DCSP_BT_LOW,
      vb:horizontal_aligner { width = 5 },
      DCSP_BT_ALL_ON, DCSP_BT_BYPASS, 
      vb:horizontal_aligner { width = 5 },
      vb:bitmap { bitmap = 'icons/deploy-ico.bmp', mode = 'body_color', height = 22, width = 20 },
      DCSP_VB_HEIGHT,
      vb:horizontal_aligner { width = 30 },
      DCSP_BT_DEF
    }
  },
  vb:horizontal_aligner { height = 4 },
  vb:horizontal_aligner {
    vb:column {
      style='panel',
      vb:vertical_aligner {
        mode = "center",
        height = 80,
        vb:horizontal_aligner {
          mode = "center",
          width = 20,
          DCSP_ICO_PRE
        }
      }
    },
    ---
    vb:horizontal_aligner { width = 2 },
    vb:column {
      style ='panel',
      width = 595,
      vb:horizontal_aligner {
        --width = 557,
        margin = 4,
        mode = 'right',
        vb:vertical_aligner {
          id = 'CENTER_COLUMN_V1',
          --width = 522,
          height = 72,
          TX_A01, TX_A02, TX_A03, TX_A04, TX_A05, TX_A06, TX_A07, TX_A08, TX_A09, TX_A10,
          TX_A11, TX_A12, TX_A13, TX_A14, TX_A15, TX_A16, TX_A17, TX_A18, TX_A19, TX_A20,
          TX_A21, TX_A22, TX_A23, TX_A24, TX_A25, TX_A26, TX_A27, TX_A28, TX_A29, TX_A30,
          TX_A31, TX_A32, TX_A33, TX_A34, TX_A35, TX_A36, TX_A37, TX_A38, TX_A39, TX_A40,
        },
        vb:vertical_aligner {
          id = 'CENTER_COLUMN_V2',
          width = 28,
          height = 72,
          DCSP_BT_A01, DCSP_BT_A02, DCSP_BT_A03, DCSP_BT_A04, DCSP_BT_A05, DCSP_BT_A06, DCSP_BT_A07, DCSP_BT_A08, DCSP_BT_A09, DCSP_BT_A10,
          DCSP_BT_A11, DCSP_BT_A12, DCSP_BT_A13, DCSP_BT_A14, DCSP_BT_A15, DCSP_BT_A16, DCSP_BT_A17, DCSP_BT_A18, DCSP_BT_A19, DCSP_BT_A20,
          DCSP_BT_A21, DCSP_BT_A22, DCSP_BT_A23, DCSP_BT_A24, DCSP_BT_A25, DCSP_BT_A26, DCSP_BT_A27, DCSP_BT_A28, DCSP_BT_A29, DCSP_BT_A30,
          DCSP_BT_A31, DCSP_BT_A32, DCSP_BT_A33, DCSP_BT_A34, DCSP_BT_A35, DCSP_BT_A36, DCSP_BT_A37, DCSP_BT_A38, DCSP_BT_A39, DCSP_BT_A40,
        }
      }
    },
    ---    
    vb:horizontal_aligner { width = 2 },
    vb:column {
      style='panel',
      vb:vertical_aligner {
        mode = "center",
        height = 80,
        vb:horizontal_aligner {
          mode = "center",
          width = 20,
          DCSP_ICO_POST
        }
      }
    },
    ---
    vb:horizontal_aligner { width = 5 },
    vb:column {
      DCSP_CN_DEV, DCSP_BT_DEL
    }
  }
}
