--------------------------------------------------------------------------------
-- Module Tool: Tool_05.lua
-- Name: AMIC: Aditional MIDI Input Control
-- Version: 1.0b
-- Author: ulneiz (Spain)
--------------------------------------------------------------------------------


--------------------------------------------------------------------------------
-- BUTTON / MIDI_MAPPING = ADD_MIDI_MAPPING / NAME
--------------------------------------------------------------------------------

class 'MR' -- MR = MIDI ROUTING

MR = {
  --Group A
  CH01_1A = "Tools:GT16-Colors AMIC:Channel 01:1A XXX [Trigger]",
  CH01_2A = "Tools:GT16-Colors AMIC:Channel 01:2A XXX [Trigger]",
  CH01_3A = "Tools:GT16-Colors AMIC:Channel 01:3A XXX [Trigger]",
  CH01_4A = "Tools:GT16-Colors AMIC:Channel 01:4A XXX [Trigger]",
  CH01_5B = "Tools:GT16-Colors AMIC:Channel 01:5B XXX [Trigger]",
  CH01_6B = "Tools:GT16-Colors AMIC:Channel 01:6B XXX [Trigger]",
  CH01_7B = "Tools:GT16-Colors AMIC:Channel 01:7B XXX [Trigger]",
  CH01_8B = "Tools:GT16-Colors AMIC:Channel 01:8B XXX [Trigger]",
  CH01_9M = "Tools:GT16-Colors AMIC:Channel 01:9M XXX [Trigger]",

  CH02_1A = "Tools:GT16-Colors AMIC:Channel 02:1A XXX [Trigger]",
  CH02_2A = "Tools:GT16-Colors AMIC:Channel 02:2A XXX [Trigger]",
  CH02_3A = "Tools:GT16-Colors AMIC:Channel 02:3A XXX [Trigger]",
  CH02_4A = "Tools:GT16-Colors AMIC:Channel 02:4A XXX [Trigger]",
  CH02_5B = "Tools:GT16-Colors AMIC:Channel 02:5B XXX [Trigger]",
  CH02_6B = "Tools:GT16-Colors AMIC:Channel 02:6B XXX [Trigger]",
  CH02_7B = "Tools:GT16-Colors AMIC:Channel 02:7B XXX [Trigger]",
  CH02_8B = "Tools:GT16-Colors AMIC:Channel 02:8B XXX [Trigger]",
  CH02_9M = "Tools:GT16-Colors AMIC:Channel 02:9M XXX [Trigger]",

  CH03_1A = "Tools:GT16-Colors AMIC:Channel 03:1A XXX [Trigger]",
  CH03_2A = "Tools:GT16-Colors AMIC:Channel 03:2A XXX [Trigger]",
  CH03_3A = "Tools:GT16-Colors AMIC:Channel 03:3A XXX [Trigger]",
  CH03_4A = "Tools:GT16-Colors AMIC:Channel 03:4A XXX [Trigger]",
  CH03_5B = "Tools:GT16-Colors AMIC:Channel 03:5B XXX [Trigger]",
  CH03_6B = "Tools:GT16-Colors AMIC:Channel 03:6B XXX [Trigger]",
  CH03_7B = "Tools:GT16-Colors AMIC:Channel 03:7B XXX [Trigger]",
  CH03_8B = "Tools:GT16-Colors AMIC:Channel 03:8B XXX [Trigger]",
  CH03_9M = "Tools:GT16-Colors AMIC:Channel 03:9M XXX [Trigger]",

  CH04_1A = "Tools:GT16-Colors AMIC:Channel 04:1A XXX [Trigger]",
  CH04_2A = "Tools:GT16-Colors AMIC:Channel 04:2A XXX [Trigger]",
  CH04_3A = "Tools:GT16-Colors AMIC:Channel 04:3A XXX [Trigger]",
  CH04_4A = "Tools:GT16-Colors AMIC:Channel 04:4A XXX [Trigger]",
  CH04_5B = "Tools:GT16-Colors AMIC:Channel 04:5B XXX [Trigger]",
  CH04_6B = "Tools:GT16-Colors AMIC:Channel 04:6B XXX [Trigger]",
  CH04_7B = "Tools:GT16-Colors AMIC:Channel 04:7B XXX [Trigger]",
  CH04_8B = "Tools:GT16-Colors AMIC:Channel 04:8B XXX [Trigger]",
  CH04_9M = "Tools:GT16-Colors AMIC:Channel 04:9M XXX [Trigger]",

  CH05_1A = "Tools:GT16-Colors AMIC:Channel 05:1A XXX [Trigger]",
  CH05_2A = "Tools:GT16-Colors AMIC:Channel 05:2A XXX [Trigger]",
  CH05_3A = "Tools:GT16-Colors AMIC:Channel 05:3A XXX [Trigger]",
  CH05_4A = "Tools:GT16-Colors AMIC:Channel 05:4A XXX [Trigger]",
  CH05_5B = "Tools:GT16-Colors AMIC:Channel 05:5B XXX [Trigger]",
  CH05_6B = "Tools:GT16-Colors AMIC:Channel 05:6B XXX [Trigger]",
  CH05_7B = "Tools:GT16-Colors AMIC:Channel 05:7B XXX [Trigger]",
  CH05_8B = "Tools:GT16-Colors AMIC:Channel 05:8B XXX [Trigger]",
  CH05_9M = "Tools:GT16-Colors AMIC:Channel 05:9M XXX [Trigger]",

  CH06_1A = "Tools:GT16-Colors AMIC:Channel 06:1A XXX [Trigger]",
  CH06_2A = "Tools:GT16-Colors AMIC:Channel 06:2A XXX [Trigger]",
  CH06_3A = "Tools:GT16-Colors AMIC:Channel 06:3A XXX [Trigger]",
  CH06_4A = "Tools:GT16-Colors AMIC:Channel 06:4A XXX [Trigger]",
  CH06_5B = "Tools:GT16-Colors AMIC:Channel 06:5B XXX [Trigger]",
  CH06_6B = "Tools:GT16-Colors AMIC:Channel 06:6B XXX [Trigger]",
  CH06_7B = "Tools:GT16-Colors AMIC:Channel 06:7B XXX [Trigger]",
  CH06_8B = "Tools:GT16-Colors AMIC:Channel 06:8B XXX [Trigger]",
  CH06_9M = "Tools:GT16-Colors AMIC:Channel 06:9M XXX [Trigger]",

  CH07_1A = "Tools:GT16-Colors AMIC:Channel 07:1A XXX [Trigger]",
  CH07_2A = "Tools:GT16-Colors AMIC:Channel 07:2A XXX [Trigger]",
  CH07_3A = "Tools:GT16-Colors AMIC:Channel 07:3A XXX [Trigger]",
  CH07_4A = "Tools:GT16-Colors AMIC:Channel 07:4A XXX [Trigger]",
  CH07_5B = "Tools:GT16-Colors AMIC:Channel 07:5B XXX [Trigger]",
  CH07_6B = "Tools:GT16-Colors AMIC:Channel 07:6B XXX [Trigger]",
  CH07_7B = "Tools:GT16-Colors AMIC:Channel 07:7B XXX [Trigger]",
  CH07_8B = "Tools:GT16-Colors AMIC:Channel 07:8B XXX [Trigger]",
  CH07_9M = "Tools:GT16-Colors AMIC:Channel 07:9M XXX [Trigger]",

  CH08_1A = "Tools:GT16-Colors AMIC:Channel 08:1A XXX [Trigger]",
  CH08_2A = "Tools:GT16-Colors AMIC:Channel 08:2A XXX [Trigger]",
  CH08_3A = "Tools:GT16-Colors AMIC:Channel 08:3A XXX [Trigger]",
  CH08_4A = "Tools:GT16-Colors AMIC:Channel 08:4A XXX [Trigger]",
  CH08_5B = "Tools:GT16-Colors AMIC:Channel 08:5B XXX [Trigger]",
  CH08_6B = "Tools:GT16-Colors AMIC:Channel 08:6B XXX [Trigger]",
  CH08_7B = "Tools:GT16-Colors AMIC:Channel 08:7B XXX [Trigger]",
  CH08_8B = "Tools:GT16-Colors AMIC:Channel 08:8B XXX [Trigger]",
  CH08_9M = "Tools:GT16-Colors AMIC:Channel 08:9M XXX [Trigger]",

  --Group B
  CH09_1A = "Tools:GT16-Colors AMIC:Channel 09:1A XXX [Trigger]",
  CH09_2A = "Tools:GT16-Colors AMIC:Channel 09:2A XXX [Trigger]",
  CH09_3A = "Tools:GT16-Colors AMIC:Channel 09:3A XXX [Trigger]",
  CH09_4A = "Tools:GT16-Colors AMIC:Channel 09:4A XXX [Trigger]",
  CH09_5B = "Tools:GT16-Colors AMIC:Channel 09:5B XXX [Trigger]",
  CH09_6B = "Tools:GT16-Colors AMIC:Channel 09:6B XXX [Trigger]",
  CH09_7B = "Tools:GT16-Colors AMIC:Channel 09:7B XXX [Trigger]",
  CH09_8B = "Tools:GT16-Colors AMIC:Channel 09:8B XXX [Trigger]",
  CH09_9M = "Tools:GT16-Colors AMIC:Channel 09:9M XXX [Trigger]",

  CH10_1A = "Tools:GT16-Colors AMIC:Channel 10:1A XXX [Trigger]",
  CH10_2A = "Tools:GT16-Colors AMIC:Channel 10:2A XXX [Trigger]",
  CH10_3A = "Tools:GT16-Colors AMIC:Channel 10:3A XXX [Trigger]",
  CH10_4A = "Tools:GT16-Colors AMIC:Channel 10:4A XXX [Trigger]",
  CH10_5B = "Tools:GT16-Colors AMIC:Channel 10:5B XXX [Trigger]",
  CH10_6B = "Tools:GT16-Colors AMIC:Channel 10:6B XXX [Trigger]",
  CH10_7B = "Tools:GT16-Colors AMIC:Channel 10:7B XXX [Trigger]",
  CH10_8B = "Tools:GT16-Colors AMIC:Channel 10:8B XXX [Trigger]",
  CH10_9M = "Tools:GT16-Colors AMIC:Channel 10:9M XXX [Trigger]",

  CH11_1A = "Tools:GT16-Colors AMIC:Channel 11:1A XXX [Trigger]",
  CH11_2A = "Tools:GT16-Colors AMIC:Channel 11:2A XXX [Trigger]",
  CH11_3A = "Tools:GT16-Colors AMIC:Channel 11:3A XXX [Trigger]",
  CH11_4A = "Tools:GT16-Colors AMIC:Channel 11:4A XXX [Trigger]",
  CH11_5B = "Tools:GT16-Colors AMIC:Channel 11:5B XXX [Trigger]",
  CH11_6B = "Tools:GT16-Colors AMIC:Channel 11:6B XXX [Trigger]",
  CH11_7B = "Tools:GT16-Colors AMIC:Channel 11:7B XXX [Trigger]",
  CH11_8B = "Tools:GT16-Colors AMIC:Channel 11:8B XXX [Trigger]",
  CH11_9M = "Tools:GT16-Colors AMIC:Channel 11:9M XXX [Trigger]",

  CH12_1A = "Tools:GT16-Colors AMIC:Channel 12:1A XXX [Trigger]",
  CH12_2A = "Tools:GT16-Colors AMIC:Channel 12:2A XXX [Trigger]",
  CH12_3A = "Tools:GT16-Colors AMIC:Channel 12:3A XXX [Trigger]",
  CH12_4A = "Tools:GT16-Colors AMIC:Channel 12:4A XXX [Trigger]",
  CH12_5B = "Tools:GT16-Colors AMIC:Channel 12:5B XXX [Trigger]",
  CH12_6B = "Tools:GT16-Colors AMIC:Channel 12:6B XXX [Trigger]",
  CH12_7B = "Tools:GT16-Colors AMIC:Channel 12:7B XXX [Trigger]",
  CH12_8B = "Tools:GT16-Colors AMIC:Channel 12:8B XXX [Trigger]",
  CH12_9M = "Tools:GT16-Colors AMIC:Channel 12:9M XXX [Trigger]",

  CH13_1A = "Tools:GT16-Colors AMIC:Channel 13:1A XXX [Trigger]",
  CH13_2A = "Tools:GT16-Colors AMIC:Channel 13:2A XXX [Trigger]",
  CH13_3A = "Tools:GT16-Colors AMIC:Channel 13:3A XXX [Trigger]",
  CH13_4A = "Tools:GT16-Colors AMIC:Channel 13:4A XXX [Trigger]",
  CH13_5B = "Tools:GT16-Colors AMIC:Channel 13:5B XXX [Trigger]",
  CH13_6B = "Tools:GT16-Colors AMIC:Channel 13:6B XXX [Trigger]",
  CH13_7B = "Tools:GT16-Colors AMIC:Channel 13:7B XXX [Trigger]",
  CH13_8B = "Tools:GT16-Colors AMIC:Channel 13:8B XXX [Trigger]",
  CH13_9M = "Tools:GT16-Colors AMIC:Channel 13:9M XXX [Trigger]",

  CH14_1A = "Tools:GT16-Colors AMIC:Channel 14:1A XXX [Trigger]",
  CH14_2A = "Tools:GT16-Colors AMIC:Channel 14:2A XXX [Trigger]",
  CH14_3A = "Tools:GT16-Colors AMIC:Channel 14:3A XXX [Trigger]",
  CH14_4A = "Tools:GT16-Colors AMIC:Channel 14:4A XXX [Trigger]",
  CH14_5B = "Tools:GT16-Colors AMIC:Channel 14:5B XXX [Trigger]",
  CH14_6B = "Tools:GT16-Colors AMIC:Channel 14:6B XXX [Trigger]",
  CH14_7B = "Tools:GT16-Colors AMIC:Channel 14:7B XXX [Trigger]",
  CH14_8B = "Tools:GT16-Colors AMIC:Channel 14:8B XXX [Trigger]",
  CH14_9M = "Tools:GT16-Colors AMIC:Channel 14:9M XXX [Trigger]",

  CH15_1A = "Tools:GT16-Colors AMIC:Channel 15:1A XXX [Trigger]",
  CH15_2A = "Tools:GT16-Colors AMIC:Channel 15:2A XXX [Trigger]",
  CH15_3A = "Tools:GT16-Colors AMIC:Channel 15:3A XXX [Trigger]",
  CH15_4A = "Tools:GT16-Colors AMIC:Channel 15:4A XXX [Trigger]",
  CH15_5B = "Tools:GT16-Colors AMIC:Channel 15:5B XXX [Trigger]",
  CH15_6B = "Tools:GT16-Colors AMIC:Channel 15:6B XXX [Trigger]",
  CH15_7B = "Tools:GT16-Colors AMIC:Channel 15:7B XXX [Trigger]",
  CH15_8B = "Tools:GT16-Colors AMIC:Channel 15:8B XXX [Trigger]",
  CH15_9M = "Tools:GT16-Colors AMIC:Channel 15:9M XXX [Trigger]",

  CH16_1A = "Tools:GT16-Colors AMIC:Channel 16:1A XXX [Trigger]",
  CH16_2A = "Tools:GT16-Colors AMIC:Channel 16:2A XXX [Trigger]",
  CH16_3A = "Tools:GT16-Colors AMIC:Channel 16:3A XXX [Trigger]",
  CH16_4A = "Tools:GT16-Colors AMIC:Channel 16:4A XXX [Trigger]",
  CH16_5B = "Tools:GT16-Colors AMIC:Channel 16:5B XXX [Trigger]",
  CH16_6B = "Tools:GT16-Colors AMIC:Channel 16:6B XXX [Trigger]",
  CH16_7B = "Tools:GT16-Colors AMIC:Channel 16:7B XXX [Trigger]",
  CH16_8B = "Tools:GT16-Colors AMIC:Channel 16:8B XXX [Trigger]",
  CH16_9M = "Tools:GT16-Colors AMIC:Channel 16:9M XXX [Trigger]"
}

class 'TP' -- TP = TOOLTIP

TP = {
  --Group A
  CH01_1A = "CH01-1A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH01_2A = "CH01-2A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH01_3A = "CH01-3A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH01_4A = "CH01-4A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH01_5B = "CH01-5B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH01_6B = "CH01-6B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH01_7B = "CH01-7B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH01_8B = "CH01-8B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH01_9M = "CH01-9M: Instructions.\n[MOUSE CLICK & MIDI INPUT]",

  CH02_1A = "CH02-1A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH02_2A = "CH02-2A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH02_3A = "CH02-3A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH02_4A = "CH02-4A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH02_5B = "CH02-5B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH02_6B = "CH02-6B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH02_7B = "CH02-7B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH02_8B = "CH02-8B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH02_9M = "CH02-9M: Instructions.\n[MOUSE CLICK & MIDI INPUT]",

  CH03_1A = "CH03-1A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH03_2A = "CH03-2A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH03_3A = "CH03-3A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH03_4A = "CH03-4A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH03_5B = "CH03-5B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH03_6B = "CH03-6B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH03_7B = "CH03-7B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH03_8B = "CH03-8B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH03_9M = "CH03-9M: Instructions.\n[MOUSE CLICK & MIDI INPUT]",

  CH04_1A = "CH04-1A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH04_2A = "CH04-2A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH04_3A = "CH04-3A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH04_4A = "CH04-4A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH04_5B = "CH04-5B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH04_6B = "CH04-6B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH04_7B = "CH04-7B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH04_8B = "CH04-8B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH04_9M = "CH04-9M: Instructions.\n[MOUSE CLICK & MIDI INPUT]",

  CH05_1A = "CH05-1A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH05_2A = "CH05-2A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH05_3A = "CH05-3A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH05_4A = "CH05-4A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH05_5B = "CH05-5B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH05_6B = "CH05-6B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH05_7B = "CH05-7B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH05_8B = "CH05-8B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH05_9M = "CH05-9M: Instructions.\n[MOUSE CLICK & MIDI INPUT]",

  CH06_1A = "CH06-1A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH06_2A = "CH06-2A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH06_3A = "CH06-3A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH06_4A = "CH06-4A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH06_5B = "CH06-5B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH06_6B = "CH06-6B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH06_7B = "CH06-7B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH06_8B = "CH06-8B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH06_9M = "CH06-9M: Instructions.\n[MOUSE CLICK & MIDI INPUT]",

  CH07_1A = "CH07-1A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH07_2A = "CH07-2A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH07_3A = "CH07-3A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH07_4A = "CH07-4A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH07_5B = "CH07-5B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH07_6B = "CH07-6B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH07_7B = "CH07-7B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH07_8B = "CH07-8B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH07_9M = "CH07-9M: Instructions.\n[MOUSE CLICK & MIDI INPUT]",

  CH08_1A = "CH08-1A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH08_2A = "CH08-2A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH08_3A = "CH08-3A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH08_4A = "CH08-4A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH08_5B = "CH08-5B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH08_6B = "CH08-6B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH08_7B = "CH08-7B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH08_8B = "CH08-8B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH08_9M = "CH08-9M: Instructions.\n[MOUSE CLICK & MIDI INPUT]",

  --Group B
  CH09_1A = "CH09-1A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH09_2A = "CH09-2A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH09_3A = "CH09-3A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH09_4A = "CH09-4A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH09_5B = "CH09-5B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH09_6B = "CH09-6B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH09_7B = "CH09-7B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH09_8B = "CH09-8B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH09_9M = "CH09-9M: Instructions.\n[MOUSE CLICK & MIDI INPUT]",

  CH10_1A = "CH10-1A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH10_2A = "CH10-2A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH10_3A = "CH10-3A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH10_4A = "CH10-4A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH10_5B = "CH10-5B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH10_6B = "CH10-6B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH10_7B = "CH10-7B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH10_8B = "CH10-8B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH10_9M = "CH10-9M: Instructions.\n[MOUSE CLICK & MIDI INPUT]",

  CH11_1A = "CH11-1A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH11_2A = "CH11-2A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH11_3A = "CH11-3A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH11_4A = "CH11-4A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH11_5B = "CH11-5B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH11_6B = "CH11-6B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH11_7B = "CH11-7B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH11_8B = "CH11-8B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH11_9M = "CH11-9M: Instructions.\n[MOUSE CLICK & MIDI INPUT]",

  CH12_1A = "CH12-1A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH12_2A = "CH12-2A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH12_3A = "CH12-3A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH12_4A = "CH12-4A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH12_5B = "CH12-5B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH12_6B = "CH12-6B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH12_7B = "CH12-7B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH12_8B = "CH12-8B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH12_9M = "CH12-9M: Instructions.\n[MOUSE CLICK & MIDI INPUT]",

  CH13_1A = "CH13-1A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH13_2A = "CH13-2A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH13_3A = "CH13-3A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH13_4A = "CH13-4A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH13_5B = "CH13-5B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH13_6B = "CH13-6B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH13_7B = "CH13-7B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH13_8B = "CH13-8B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH13_9M = "CH13-9M: Instructions.\n[MOUSE CLICK & MIDI INPUT]",

  CH14_1A = "CH14-1A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH14_2A = "CH14-2A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH14_3A = "CH14-3A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH14_4A = "CH14-4A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH14_5B = "CH14-5B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH14_6B = "CH14-6B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH14_7B = "CH14-7B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH14_8B = "CH14-8B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH14_9M = "CH14-9M: Instructions.\n[MOUSE CLICK & MIDI INPUT]",

  CH15_1A = "CH15-1A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH15_2A = "CH15-2A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH15_3A = "CH15-3A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH15_4A = "CH15-4A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH15_5B = "CH15-5B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH15_6B = "CH15-6B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH15_7B = "CH15-7B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH15_8B = "CH15-8B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH15_9M = "CH15-9M: Instructions.\n[MOUSE CLICK & MIDI INPUT]",

  CH16_1A = "CH16-1A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH16_2A = "CH16-2A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH16_3A = "CH16-3A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH16_4A = "CH16-4A: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH16_5B = "CH16-5B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH16_6B = "CH16-6B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH16_7B = "CH16-7B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH16_8B = "CH16-8B: Instructions.\n[MOUSE CLICK & MIDI INPUT]",
  CH16_9M = "CH16-9M: Instructions.\n[MOUSE CLICK & MIDI INPUT]"
}

class 'CR' -- CR = COLOR

CR = {
  --Group A
  ROW01_X = { 0x40,0x00,0x80 }, --Violet
  ROW01_Y = { 0x5F,0x0C,0x89 },
  ROW01_Z = { 0x3F,0x01,0x89 },
  ROW01_F = { 0x8F,0x3C,0xB9 }, -- --(Focus)
  
  ROW02_X = { 0x06,0x2B,0x50 }, --Blue
  ROW02_Y = { 0x06,0x3B,0x70 },
  ROW02_Z = { 0x06,0x1B,0x70 },
  ROW03_X = { 0x8A,0x4A,0x00 }, --Gold
  ROW03_Y = { 0xAA,0x6A,0x00 },
  ROW03_Z = { 0x7A,0x3A,0x00 },
  ROW04_X = { 0x56,0x00,0x00 }, --Red
  ROW04_Y = { 0x76,0x00,0x00 },
  ROW04_Z = { 0x46,0x00,0x00 },
  ROW05_X = { 0x00,0x50,0x00 }, --Green
  ROW05_Y = { 0x00,0x70,0x00 },
  ROW05_Z = { 0x00,0x40,0x00 },
  ROW06_X = { 0x90,0x00,0x60 }, --Pink
  ROW06_Y = { 0xA0,0x00,0x70 },
  ROW06_Z = { 0x70,0x00,0x40 },
  ROW07_X = { 0x80,0x80,0x00 }, --Yellow
  ROW07_Y = { 0xA0,0xA0,0x00 },
  ROW07_Z = { 0x70,0x70,0x00 },
  ROW08_X = { 0x00,0x60,0x4C }, --Aqua
  ROW08_Y = { 0x00,0x7A,0x6D },
  ROW08_Z = { 0x00,0x50,0x3C },
  --Group B
  ROW09_X = { 0x40,0x00,0x80 },
  ROW09_Y = { 0x40,0x00,0x80 },
  ROW09_Z = { 0x40,0x00,0x80 },
  ROW10_X = { 0x40,0x00,0x80 },
  ROW10_Y = { 0x40,0x00,0x80 },
  ROW10_Z = { 0x40,0x00,0x80 },
  ROW11_X = { 0x40,0x00,0x80 },
  ROW11_Y = { 0x40,0x00,0x80 },
  ROW11_Z = { 0x40,0x00,0x80 },
  ROW12_X = { 0x40,0x00,0x80 },
  ROW12_Y = { 0x40,0x00,0x80 },
  ROW12_Z = { 0x40,0x00,0x80 },
  ROW13_X = { 0x40,0x00,0x80 },
  ROW13_Y = { 0x40,0x00,0x80 },
  ROW13_Z = { 0x40,0x00,0x80 },
  ROW14_X = { 0x40,0x00,0x80 },
  ROW14_Y = { 0x40,0x00,0x80 },
  ROW14_Z = { 0x40,0x00,0x80 },
  ROW15_X = { 0x40,0x00,0x80 },
  ROW15_Y = { 0x40,0x00,0x80 },
  ROW15_Z = { 0x40,0x00,0x80 },
  ROW16_X = { 0x40,0x00,0x80 },
  ROW16_Y = { 0x40,0x00,0x80 },
  ROW16_Z = { 0x40,0x00,0x80 }
}
--------------------------------------------------------------------------------
-- TEXT & +INFO
--------------------------------------------------------------------------------
--Group A
txt_ch01A = vb:text { text =
  " 1 A: \n"..
  " 2 A: \n"..
  " 3 A: \n"..
  " 4 A: "
}
txt_ch01B = vb:text { text =
  " 5 B: \n"..
  " 6 B: \n"..
  " 7 B: \n"..
  " 8 B: \n"..
  " 9 M: "
}

txt_ch02A = vb:text { text =
  " 1 A: \n"..
  " 2 A: \n"..
  " 3 A: \n"..
  " 4 A: "
}
txt_ch02B = vb:text { text =
  " 5 B: \n"..
  " 6 B: \n"..
  " 7 B: \n"..
  " 8 B: \n"..
  " 9 M: "
}

txt_ch03A = vb:text { text =
  " 1 A: \n"..
  " 2 A: \n"..
  " 3 A: \n"..
  " 4 A: "
}
txt_ch03B = vb:text { text =
  " 5 B: \n"..
  " 6 B: \n"..
  " 7 B: \n"..
  " 8 B: \n"..
  " 9 M: "
}

txt_ch04A = vb:text { text =
  " 1 A: \n"..
  " 2 A: \n"..
  " 3 A: \n"..
  " 4 A: "
}
txt_ch04B = vb:text { text =
  " 5 B: \n"..
  " 6 B: \n"..
  " 7 B: \n"..
  " 8 B: \n"..
  " 9 M: "
}

txt_ch05A = vb:text { text =
  " 1 A: \n"..
  " 2 A: \n"..
  " 3 A: \n"..
  " 4 A: "
}
txt_ch05B = vb:text { text =
  " 5 B: \n"..
  " 6 B: \n"..
  " 7 B: \n"..
  " 8 B: \n"..
  " 9 M: "
}

txt_ch06A = vb:text { text =
  " 1 A: \n"..
  " 2 A: \n"..
  " 3 A: \n"..
  " 4 A: "
}
txt_ch06B = vb:text { text =
  " 5 B: \n"..
  " 6 B: \n"..
  " 7 B: \n"..
  " 8 B: \n"..
  " 9 M: "
}

txt_ch07A = vb:text { text =
  " 1 A: \n"..
  " 2 A: \n"..
  " 3 A: \n"..
  " 4 A: "
}
txt_ch07B = vb:text { text =
  " 5 B: \n"..
  " 6 B: \n"..
  " 7 B: \n"..
  " 8 B: \n"..
  " 9 M: "
}

txt_ch08A = vb:text { text =
  " 1 A: \n"..
  " 2 A: \n"..
  " 3 A: \n"..
  " 4 A: "
}
txt_ch08B = vb:text { text =
  " 5 B: \n"..
  " 6 B: \n"..
  " 7 B: \n"..
  " 8 B: \n"..
  " 9 M: "
}

--Group B
txt_ch09A = vb:text { text =
  " 1 A: \n"..
  " 2 A: \n"..
  " 3 A: \n"..
  " 4 A: "
}
txt_ch09B = vb:text { text =
  " 5 B: \n"..
  " 6 B: \n"..
  " 7 B: \n"..
  " 8 B: \n"..
  " 9 M: "
}

txt_ch10A = vb:text { text =
  " 1 A: \n"..
  " 2 A: \n"..
  " 3 A: \n"..
  " 4 A: "
}
txt_ch10B = vb:text { text =
  " 5 B: \n"..
  " 6 B: \n"..
  " 7 B: \n"..
  " 8 B: \n"..
  " 9 M: "
}
txt_ch11A = vb:text { text =
  " 1 A: \n"..
  " 2 A: \n"..
  " 3 A: \n"..
  " 4 A: "
}
txt_ch11B = vb:text { text =
  " 5 B: \n"..
  " 6 B: \n"..
  " 7 B: \n"..
  " 8 B: \n"..
  " 9 M: "
}

txt_ch12A = vb:text { text =
  " 1 A: \n"..
  " 2 A: \n"..
  " 3 A: \n"..
  " 4 A: "
}
txt_ch12B = vb:text { text =
  " 5 B: \n"..
  " 6 B: \n"..
  " 7 B: \n"..
  " 8 B: \n"..
  " 9 M: "
}

txt_ch13A = vb:text { text =
  " 1 A: \n"..
  " 2 A: \n"..
  " 3 A: \n"..
  " 4 A: "
}
txt_ch13B = vb:text { text =
  " 5 B: \n"..
  " 6 B: \n"..
  " 7 B: \n"..
  " 8 B: \n"..
  " 9 M: "
}

txt_ch14A = vb:text { text =
  " 1 A: \n"..
  " 2 A: \n"..
  " 3 A: \n"..
  " 4 A: "
}
txt_ch14B = vb:text { text =
  " 5 B: \n"..
  " 6 B: \n"..
  " 7 B: \n"..
  " 8 B: \n"..
  " 9 M: "
}

txt_ch15A = vb:text { text =
  " 1 A: \n"..
  " 2 A: \n"..
  " 3 A: \n"..
  " 4 A: "
}
txt_ch15B = vb:text { text =
  " 5 B: \n"..
  " 6 B: \n"..
  " 7 B: \n"..
  " 8 B: \n"..
  " 9 M: "
}

txt_ch16A = vb:text { text =
  " 1 A: \n"..
  " 2 A: \n"..
  " 3 A: \n"..
  " 4 A: "
}
txt_ch16B = vb:text { text =
  " 5 B: \n"..
  " 6 B: \n"..
  " 7 B: \n"..
  " 8 B: \n"..
  " 9 M: "
}


txt_info = vb:text { text =
  "⚫ 144 new buttons [(8 + 8) rows x 9 columns] for MIDI Routing Input with specific aditional functions. \n"..
  "⚫ Use until 16 MIDI Channels for route each button with your MIDI Keyboard or MIDI Pad Controller. \n"..
  "⚫ Each row is formed for a configuration of 4 + 4 + 1 buttons, for create groups, regarding the MIDI Controller. \n"..
  "⚫ Two Channel Groups [01-08 , 09-16]. The buttons form a matrix of 8x8 or 4x4 (x4) for MIDI Pad Controllers.  \n"..
  "⚫ Some rows are reserved for future expand."
}


--------------------------------------------------------------------------------
-- 01-08_09-16 TAB NAVIGATION
--------------------------------------------------------------------------------

ABTAB_T = 1
ABTAB_F = 2

function LOG(...) print (...) end -- log print
-- ABTAB Control------------------
-- show/update the indicated tab
function show_abtab( idx )
  LOG( 'show_abtab()' , idx )
  vb.views.abtab_t.visible = ( idx == ABTAB_T ) and true or false
  vb.views.abtab_f.visible = ( idx == ABTAB_F ) and true or false
end

-- next/previous abtab
function show_next_abtab()
  local new_abtab = visible_abtab
  if ( visible_abtab == ABTAB_F ) then
    new_attab = ABTAB_T
    else
    new_abtab = new_abtab + 1
  end
  vb.views.ab_switch.value = new_abtab
end

function show_previous_abtab()
  local new_abtab = visible_abtab
  if ( visible_abtab == ABTAB_T ) then
    new_abtab = ABTAB_F
    else
    new_abtab = new_abtab - 1
  end
  vb.views.ab_switch.value = new_abtab
end

-- force update of current abtab
function update_abtab()
  local abtab_idx = visible_abtab
  visible_abtab = 0
  show_abtab( abtab_idx )
end


  swi_cl_abmenu =  vb:switch { items = {'01-08', '09-16' }, id = 'ab_switch', tooltip = 'Channel Group 01-08  [MOUSE CLICK]\nChannel Group 09-16  [MOUSE CLICK]',
                               notifier = function(new_index) show_abtab(new_index) end, width = 96, height = 20, value = 1 }  -- show_abtab(2)



--------------------------------------------------------------------------------
-- FUNCTION FOR CHECKBOX (SHOW or HIDE TEXT & +INFO...)
--------------------------------------------------------------------------------
--A
function show_cbox_amic_01( idx )
  LOG( 'show_cbox_amic_01()' , idx )
  vb.views.cbox_amic_01_t.visible = ( idx == true )
  vb.views.cbox_amic_01_f.visible = ( idx == false )
end

function show_cbox_amic_02( idx )
  LOG( 'show_cbox_amic_02()' , idx )
  vb.views.cbox_amic_02_t.visible = ( idx == true )
  vb.views.cbox_amic_02_f.visible = ( idx == false )
end

function show_cbox_amic_03( idx )
  LOG( 'show_cbox_amic_03()' , idx )
  vb.views.cbox_amic_03_t.visible = ( idx == true )
  vb.views.cbox_amic_03_f.visible = ( idx == false )
end

function show_cbox_amic_04( idx )
  LOG( 'show_cbox_amic_04()' , idx )
  vb.views.cbox_amic_04_t.visible = ( idx == true )
  vb.views.cbox_amic_04_f.visible = ( idx == false )
end

function show_cbox_amic_05( idx )
  LOG( 'show_cbox_amic_05()' , idx )
  vb.views.cbox_amic_05_t.visible = ( idx == true )
  vb.views.cbox_amic_05_f.visible = ( idx == false )
end

function show_cbox_amic_06( idx )
  LOG( 'show_cbox_amic_06()' , idx )
  vb.views.cbox_amic_06_t.visible = ( idx == true )
  vb.views.cbox_amic_06_f.visible = ( idx == false )
end

function show_cbox_amic_07( idx )
  LOG( 'show_cbox_amic_07()' , idx )
  vb.views.cbox_amic_07_t.visible = ( idx == true )
  vb.views.cbox_amic_07_f.visible = ( idx == false )
end

function show_cbox_amic_08( idx )
  LOG( 'show_cbox_amic_08()' , idx )
  vb.views.cbox_amic_08_t.visible = ( idx == true )
  vb.views.cbox_amic_08_f.visible = ( idx == false )
end
--B
function show_cbox_amic_09( idx )
  LOG( 'show_cbox_amic_09()' , idx )
  vb.views.cbox_amic_09_t.visible = ( idx == true )
  vb.views.cbox_amic_09_f.visible = ( idx == false )
end

function show_cbox_amic_10( idx )
  LOG( 'show_cbox_amic_10()' , idx )
  vb.views.cbox_amic_10_t.visible = ( idx == true )
  vb.views.cbox_amic_10_f.visible = ( idx == false )
end

function show_cbox_amic_11( idx )
  LOG( 'show_cbox_amic_11()' , idx )
  vb.views.cbox_amic_11_t.visible = ( idx == true )
  vb.views.cbox_amic_11_f.visible = ( idx == false )
end

function show_cbox_amic_12( idx )
  LOG( 'show_cbox_amic_12()' , idx )
  vb.views.cbox_amic_12_t.visible = ( idx == true )
  vb.views.cbox_amic_12_f.visible = ( idx == false )
end

function show_cbox_amic_13( idx )
  LOG( 'show_cbox_amic_13()' , idx )
  vb.views.cbox_amic_13_t.visible = ( idx == true )
  vb.views.cbox_amic_13_f.visible = ( idx == false )
end

function show_cbox_amic_14( idx )
  LOG( 'show_cbox_amic_14()' , idx )
  vb.views.cbox_amic_14_t.visible = ( idx == true )
  vb.views.cbox_amic_14_f.visible = ( idx == false )
end

function show_cbox_amic_15( idx )
  LOG( 'show_cbox_amic_15()' , idx )
  vb.views.cbox_amic_15_t.visible = ( idx == true )
  vb.views.cbox_amic_15_f.visible = ( idx == false )
end

function show_cbox_amic_16( idx )
  LOG( 'show_cbox_amic_16()' , idx )
  vb.views.cbox_amic_16_t.visible = ( idx == true )
  vb.views.cbox_amic_16_f.visible = ( idx == false )
end
--- ---
--- ---
--A
function show_cbox_amic_ch01( idx )
  LOG( 'show_cbox_amic_ch01()' , idx )
  vb.views.cbox_amic_ch01_t.visible = ( idx == true )
  vb.views.cbox_amic_ch01_f.visible = ( idx == false )
end

function show_cbox_amic_ch02( idx )
  LOG( 'show_cbox_amic_ch02()' , idx )
  vb.views.cbox_amic_ch02_t.visible = ( idx == true )
  vb.views.cbox_amic_ch02_f.visible = ( idx == false )
end

function show_cbox_amic_ch03( idx )
  LOG( 'show_cbox_amic_ch03()' , idx )
  vb.views.cbox_amic_ch03_t.visible = ( idx == true )
  vb.views.cbox_amic_ch03_f.visible = ( idx == false )
end

function show_cbox_amic_ch04( idx )
  LOG( 'show_cbox_amic_ch04()' , idx )
  vb.views.cbox_amic_ch04_t.visible = ( idx == true )
  vb.views.cbox_amic_ch04_f.visible = ( idx == false )
end

function show_cbox_amic_ch05( idx )
  LOG( 'show_cbox_amic_ch05()' , idx )
  vb.views.cbox_amic_ch05_t.visible = ( idx == true )
  vb.views.cbox_amic_ch05_f.visible = ( idx == false )
end

function show_cbox_amic_ch06( idx )
  LOG( 'show_cbox_amic_ch06()' , idx )
  vb.views.cbox_amic_ch06_t.visible = ( idx == true )
  vb.views.cbox_amic_ch06_f.visible = ( idx == false )
end

function show_cbox_amic_ch07( idx )
  LOG( 'show_cbox_amic_ch07()' , idx )
  vb.views.cbox_amic_ch07_t.visible = ( idx == true )
  vb.views.cbox_amic_ch07_f.visible = ( idx == false )
end

function show_cbox_amic_ch08( idx )
  LOG( 'show_cbox_amic_ch08()' , idx )
  vb.views.cbox_amic_ch08_t.visible = ( idx == true )
  vb.views.cbox_amic_ch08_f.visible = ( idx == false )
end
--B
function show_cbox_amic_ch09( idx )
  LOG( 'show_cbox_amic_ch09()' , idx )
  vb.views.cbox_amic_ch09_t.visible = ( idx == true )
  vb.views.cbox_amic_ch09_f.visible = ( idx == false )
end

function show_cbox_amic_ch10( idx )
  LOG( 'show_cbox_amic_ch10()' , idx )
  vb.views.cbox_amic_ch10_t.visible = ( idx == true )
  vb.views.cbox_amic_ch10_f.visible = ( idx == false )
end
function show_cbox_amic_ch11( idx )
  LOG( 'show_cbox_amic_ch11()' , idx )
  vb.views.cbox_amic_ch11_t.visible = ( idx == true )
  vb.views.cbox_amic_ch11_f.visible = ( idx == false )
end

function show_cbox_amic_ch12( idx )
  LOG( 'show_cbox_amic_ch12()' , idx )
  vb.views.cbox_amic_ch12_t.visible = ( idx == true )
  vb.views.cbox_amic_ch12_f.visible = ( idx == false )
end

function show_cbox_amic_ch13( idx )
  LOG( 'show_cbox_amic_ch13()' , idx )
  vb.views.cbox_amic_ch13_t.visible = ( idx == true )
  vb.views.cbox_amic_ch13_f.visible = ( idx == false )
end

function show_cbox_amic_ch14( idx )
  LOG( 'show_cbox_amic_ch14()' , idx )
  vb.views.cbox_amic_ch14_t.visible = ( idx == true )
  vb.views.cbox_amic_ch14_f.visible = ( idx == false )
end

function show_cbox_amic_ch15( idx )
  LOG( 'show_cbox_amic_ch15()' , idx )
  vb.views.cbox_amic_ch15_t.visible = ( idx == true )
  vb.views.cbox_amic_ch15_f.visible = ( idx == false )
end

function show_cbox_amic_ch16( idx )
  LOG( 'show_cbox_amic_ch16()' , idx )
  vb.views.cbox_amic_ch16_t.visible = ( idx == true )
  vb.views.cbox_amic_ch16_f.visible = ( idx == false )
end
--- ---
function show_cbox_amic_info( idx )
  LOG( 'show_cbox_amic_info()' , idx )
  vb.views.cbox_amic_info_t.visible = ( idx == true )
  vb.views.cbox_amic_info_f.visible = ( idx == false )
end

--A
checkbox_amic_01 = vb:checkbox { id = 'cbox_amic_01', value = true,  notifier = function(new_idx) show_cbox_amic_01(new_idx) end, tooltip = 'Violet Group: Ch01' }
checkbox_amic_02 = vb:checkbox { id = 'cbox_amic_02', value = true,  notifier = function(new_idx) show_cbox_amic_02(new_idx) end, tooltip = 'Blue Group: Ch02' }
checkbox_amic_03 = vb:checkbox { id = 'cbox_amic_03', value = true,  notifier = function(new_idx) show_cbox_amic_03(new_idx) end, tooltip = 'Orange Group: Ch03' }
checkbox_amic_04 = vb:checkbox { id = 'cbox_amic_04', value = true,  notifier = function(new_idx) show_cbox_amic_04(new_idx) end, tooltip = 'Red Group: Ch04' }
checkbox_amic_05 = vb:checkbox { id = 'cbox_amic_05', value = false, notifier = function(new_idx) show_cbox_amic_05(new_idx) end, tooltip = 'Green Group: Ch05' }
checkbox_amic_06 = vb:checkbox { id = 'cbox_amic_06', value = false, notifier = function(new_idx) show_cbox_amic_06(new_idx) end, tooltip = 'Green Group: Ch06' }
checkbox_amic_07 = vb:checkbox { id = 'cbox_amic_07', value = false, notifier = function(new_idx) show_cbox_amic_07(new_idx) end, tooltip = 'Red Group: Ch07' }
checkbox_amic_08 = vb:checkbox { id = 'cbox_amic_08', value = false, notifier = function(new_idx) show_cbox_amic_08(new_idx) end, tooltip = 'Green Group: Ch08' }
--B
checkbox_amic_09 = vb:checkbox { id = 'cbox_amic_09', value = true,  notifier = function(new_idx) show_cbox_amic_09(new_idx) end, tooltip = 'Green Group: Ch09' }
checkbox_amic_10 = vb:checkbox { id = 'cbox_amic_10', value = true,  notifier = function(new_idx) show_cbox_amic_10(new_idx) end, tooltip = 'Violet Group: Ch10' }
checkbox_amic_11 = vb:checkbox { id = 'cbox_amic_11', value = true,  notifier = function(new_idx) show_cbox_amic_11(new_idx) end, tooltip = 'Violet Group: Ch11' }
checkbox_amic_12 = vb:checkbox { id = 'cbox_amic_12', value = true,  notifier = function(new_idx) show_cbox_amic_12(new_idx) end, tooltip = 'Blue Group: Ch12' }
checkbox_amic_13 = vb:checkbox { id = 'cbox_amic_13', value = false, notifier = function(new_idx) show_cbox_amic_13(new_idx) end, tooltip = 'Orange Group: Ch13' }
checkbox_amic_14 = vb:checkbox { id = 'cbox_amic_14', value = false, notifier = function(new_idx) show_cbox_amic_14(new_idx) end, tooltip = 'Red Group: Ch14' }
checkbox_amic_15 = vb:checkbox { id = 'cbox_amic_15', value = false, notifier = function(new_idx) show_cbox_amic_15(new_idx) end, tooltip = 'Green Group: Ch15' }
checkbox_amic_16 = vb:checkbox { id = 'cbox_amic_16', value = false, notifier = function(new_idx) show_cbox_amic_16(new_idx) end, tooltip = 'Green Group: Ch16' }
--- ---
--- ---
--A
checkbox_amic_ch01 = vb:checkbox { id = 'cbox_amic_ch01', notifier = function(new_idx) show_cbox_amic_ch01(new_idx) end }
checkbox_amic_ch02 = vb:checkbox { id = 'cbox_amic_ch02', notifier = function(new_idx) show_cbox_amic_ch02(new_idx) end }
checkbox_amic_ch03 = vb:checkbox { id = 'cbox_amic_ch03', notifier = function(new_idx) show_cbox_amic_ch03(new_idx) end }
checkbox_amic_ch04 = vb:checkbox { id = 'cbox_amic_ch04', notifier = function(new_idx) show_cbox_amic_ch04(new_idx) end }
checkbox_amic_ch05 = vb:checkbox { id = 'cbox_amic_ch05', notifier = function(new_idx) show_cbox_amic_ch05(new_idx) end }
checkbox_amic_ch06 = vb:checkbox { id = 'cbox_amic_ch06', notifier = function(new_idx) show_cbox_amic_ch06(new_idx) end }
checkbox_amic_ch07 = vb:checkbox { id = 'cbox_amic_ch07', notifier = function(new_idx) show_cbox_amic_ch07(new_idx) end }
checkbox_amic_ch08 = vb:checkbox { id = 'cbox_amic_ch08', notifier = function(new_idx) show_cbox_amic_ch08(new_idx) end }
--B
checkbox_amic_ch09 = vb:checkbox { id = 'cbox_amic_ch09', notifier = function(new_idx) show_cbox_amic_ch09(new_idx) end }
checkbox_amic_ch10 = vb:checkbox { id = 'cbox_amic_ch10', notifier = function(new_idx) show_cbox_amic_ch10(new_idx) end }
checkbox_amic_ch11 = vb:checkbox { id = 'cbox_amic_ch11', notifier = function(new_idx) show_cbox_amic_ch11(new_idx) end }
checkbox_amic_ch12 = vb:checkbox { id = 'cbox_amic_ch12', notifier = function(new_idx) show_cbox_amic_ch12(new_idx) end }
checkbox_amic_ch13 = vb:checkbox { id = 'cbox_amic_ch13', notifier = function(new_idx) show_cbox_amic_ch13(new_idx) end }
checkbox_amic_ch14 = vb:checkbox { id = 'cbox_amic_ch14', notifier = function(new_idx) show_cbox_amic_ch14(new_idx) end }
checkbox_amic_ch15 = vb:checkbox { id = 'cbox_amic_ch15', notifier = function(new_idx) show_cbox_amic_ch15(new_idx) end }
checkbox_amic_ch16 = vb:checkbox { id = 'cbox_amic_ch16', notifier = function(new_idx) show_cbox_amic_ch16(new_idx) end }
--- ---
checkbox_amic_info = vb:checkbox { id = 'cbox_amic_info', notifier = function(new_idx) show_cbox_amic_info(new_idx) end }



--------------------------------------------------------------------------------
-- PRINCIPAL FUNCTIONS FOR MIDI BUTTONS
--------------------------------------------------------------------------------

--- --- --- --- ---
-- CHANNEL 01
--- --- --- --- ---
--Undo
function amic_CH01_1A()
  renoise.song():undo()
  renoise.app():show_status( "GT16-Colors AMIC:  Undo." )
end

--Redo
function amic_CH01_2A()
  renoise.song():redo()
  renoise.app():show_status( "GT16-Colors AMIC:  Redo." )
end

--Play/Off Track/Group/Send
function amic_CH01_3A( song, A )
  song = renoise.song()
  if ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) or 
     ( song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) or
     ( song.selected_track.type == renoise.Track.TRACK_TYPE_SEND ) then
    A = song.tracks[song.selected_track_index].mute_state
  end
  if A == 1 then song.tracks[song.selected_track_index]:mute()
    if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) then
      renoise.app():show_status( "GT16-Colors AMIC:  selected Track Off." )
  end
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
      renoise.app():show_status( "GT16-Colors AMIC:  selected Group Off." )
  end
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEND) then
      renoise.app():show_status( "GT16-Colors AMIC:  selected Send Off." )
  end
  elseif A == 2 then song.tracks[song.selected_track_index]:unmute()
    if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) then
      renoise.app():show_status( "GT16-Colors AMIC:  selected Track Play." )
  end
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
      renoise.app():show_status( "GT16-Colors AMIC:  selected Group Play." )
  end
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEND) then
      renoise.app():show_status( "GT16-Colors AMIC:  selected Send Play." )
  end
  else 
  renoise.app():show_status( "GT16-Colors AMIC:  please, for Play/Off select before a Track/Group/Send in Pattern Editor or Mixer!!!" )
  end
end

--Collapse/Expand Track/Group/Master/Send
function amic_CH01_4A( song, selected_track, A )
  song = renoise.song()
  selected_track = song.tracks[ song.selected_track_index ]
  if ( selected_track.type == renoise.Track.TRACK_TYPE_GROUP ) then
    for i = 1, #selected_track.members do
      A = selected_track.members[ i ]
          if ( A.collapsed == T ) then A.collapsed = F -- False is expanded
        renoise.app():show_status( "GT16-Colors AMIC:  selected Group expanded." )
      elseif ( A.collapsed == F ) then A.collapsed = T -- True is collapsed
          renoise.app():show_status( "GT16-Colors AMIC:  selected Group collapsed." )
      end
    end
  end
  if ( selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) or
     ( selected_track.type == renoise.Track.TRACK_TYPE_MASTER ) or
   ( selected_track.type == renoise.Track.TRACK_TYPE_SEND ) then
    if selected_track.collapsed == T then song.tracks[song.selected_track_index].collapsed = F
      if ( selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
        renoise.app():show_status( "GT16-Colors AMIC:  selected Track expanded." )
        end
      if ( selected_track.type == renoise.Track.TRACK_TYPE_MASTER ) then
        renoise.app():show_status( "GT16-Colors AMIC:  selected Master expanded." )
        end
      if ( selected_track.type == renoise.Track.TRACK_TYPE_SEND ) then
        renoise.app():show_status( "GT16-Colors AMIC:  selected Send expanded." )
      end
      elseif selected_track.collapsed == F then song.tracks[song.selected_track_index].collapsed = T
      if ( selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER ) then
        renoise.app():show_status( "GT16-Colors AMIC:  selected Track colapsed." )
      end
      if ( selected_track.type == renoise.Track.TRACK_TYPE_MASTER ) then
        renoise.app():show_status( "GT16-Colors AMIC:  selected Master colapsed." )
      end
      if ( selected_track.type == renoise.Track.TRACK_TYPE_SEND ) then
        renoise.app():show_status( "GT16-Colors AMIC:  selected Send colapsed." )
      end
    end
  end 
end

--Jump previous pattern
function amic_CH01_5B( song, sid )
  song = renoise.song()
  sid = song.selected_sequence_index
  if song.selected_sequence_index > 1 then
    song.selected_sequence_index = sid - 1 --select next pattern
    renoise.app():show_status( "GT16-Colors AMIC:  previous Pattern." )
  end
end

--Jump next pattern
function amic_CH01_6B( song, sid )
  song = renoise.song()
  sid = song.selected_sequence_index
  if #song.sequencer.pattern_sequence > ( sid ) then
    song.selected_sequence_index = sid + 1 --select next pattern
    renoise.app():show_status( "GT16-Colors AMIC:  next Pattern." )
  end
end

--Jump previous 4 patterns
function amic_CH01_7B( song, sid )
  song = renoise.song()
  sid = song.selected_sequence_index
  if song.selected_sequence_index > 4 then
    song.selected_sequence_index = sid - 4 --select next pattern
    renoise.app():show_status( "GT16-Colors AMIC:  jump previous 4 Patterns." )
  end
end

--Jump next 4 patterns
function amic_CH01_8B( song, sid )
  song = renoise.song()
  sid = song.selected_sequence_index
  if #song.sequencer.pattern_sequence >= sid + 4 then
    song.selected_sequence_index = sid + 4 --select next pattern
    renoise.app():show_status( "GT16-Colors AMIC:  jump next 4 Patterns." )
  end
end

--Jump first pattern
function amic_CH01_9M( song )
  song = renoise.song()
  song.selected_sequence_index = 1
end



--- --- --- --- ---
-- CHANNEL 02
--- --- --- --- ---
--Insert 1 new pattern
function amic_CH02_1A( song, sid )
  song = renoise.song()
  sid = song.selected_sequence_index
  song.sequencer:insert_new_pattern_at( sid + 1 ) --insert next pattern
  song.selected_sequence_index = sid + 1 --select next pattern
  song.sequencer:sort() --sort sequence
  renoise.app():show_status( "GT16-Colors AMIC:  new pattern inserted." )
end

--Insert 4 new patterns
function amic_CH02_2A( song, sid, n )
  song = renoise.song()
  sid = song.selected_sequence_index
  n = 4
  for i = 1, n do
    song.sequencer:insert_new_pattern_at( sid + 1) --insert next pattern
  end
  song.selected_sequence_index = sid + n --select next pattern
  song.sequencer:sort() --order sequence
  renoise.app():show_status( "GT16-Colors AMIC:  new 4 patterns inserted." )
end

--Start new section renowed & insert 4 new patterns
function amic_CH02_3A( song, sid, name, n )
  song = renoise.song()
  sid = song.selected_sequence_index
  name = "SECTION x4"
  n = 4
  song.sequencer:set_sequence_is_start_of_section( sid, true ) --start a new section at the current pattern
  song.sequencer:set_sequence_section_name( sid, name ) --sets a section name
  for i = 1, n do
    song.sequencer:insert_new_pattern_at( sid + 1 ) --insert "n" patterns
  end
  song.selected_sequence_index = sid + n --select next pattern
  song.sequencer:sort() --sort sequence
  renoise.app():show_status( "GT16-Colors AMIC:  new section renowned & new 4 patterns inserted & ." )
end

--Insert 8 new patterns
function amic_CH02_4A( song, sid, n )
  song = renoise.song()
  sid = song.selected_sequence_index
  n = 8
  for i = 1, n do
    song.sequencer:insert_new_pattern_at( sid + 1 ) --insert next pattern
  end
  song.selected_sequence_index = sid + n --select next pattern
  song.sequencer:sort() --order sequence
  renoise.app():show_status( "GT16-Colors AMIC:  new 8 patterns inserted." )
end

--Start new section renowed & insert 8 new patterns
function amic_CH02_5B( song, sid, name, n )
  song = renoise.song()
  sid = song.selected_sequence_index
  name = "SECTION x8"
  n = 8
  song.sequencer:set_sequence_is_start_of_section( sid, true ) --start a new section at the current pattern
  song.sequencer:set_sequence_section_name( sid, name ) --sets a section name
  for i = 1, n do
    song.sequencer:insert_new_pattern_at( sid + 1 ) --insert "n" patterns
  end
  song.selected_sequence_index = sid + n --select next pattern
  song.sequencer:sort() --sort sequence
  renoise.app():show_status( "GT16-Colors AMIC:  new section renowned & new 8 patterns inserted & ." )
end

--Clone 1 pattern
function amic_CH02_6B( song, sid )
  song = renoise.song()
  sid = song.selected_sequence_index
  song.sequencer:clone_range( sid , sid ) --clone
  song.selected_sequence_index = sid + 1 --select next pattern
  song.sequencer:sort() --sort sequence
  renoise.app():show_status( "GT16-Colors, AMIC:  selected pattern cloned." )
end

--Clone previous 2 patterns
function amic_CH02_7B( song, sid, n )
  song = renoise.song()
  sid = song.selected_sequence_index
  n = 1 --number of clones
  if sid >= 2 then
    for i = 1, n do
      i = i + 1
      song.sequencer:clone_range( sid , sid - 1 )
    end
    song.selected_sequence_index = sid + 2
    song.sequencer:sort() --sort sequence
    renoise.app():show_status( "GT16-Colors, AMIC:  previous 2 patterns cloned." )
    else
    renoise.app():show_status( "⚠ GT16-Colors, AMIC:  please, select the last block pattern to clone x2!" )
  end
end

--Clone previous 4 patterns
function amic_CH02_8B( song, sid, n )
  song = renoise.song()
  sid = song.selected_sequence_index
  n = 1 --number of clones
  if sid >= 4 then
    for i = 1, n do
      i = i + 1
      song.sequencer:clone_range( sid , sid - 3 )
    end
    song.selected_sequence_index = sid + 4
    song.sequencer:sort() --sort sequence
    renoise.app():show_status( "GT16-Colors, AMIC:  previous 4 patterns cloned." )
    else
    renoise.app():show_status( "⚠ GT16-Colors, AMIC:  please, select the last block pattern to clone x4!" )
  end
end

--Clone previous 8 patterns
function amic_CH02_9M( song, sid, n )
  song = renoise.song()
  sid = song.selected_sequence_index
  n = 1 --number of clones
  if sid >= 8 then
    for i = 1, n do
      i = i + 1
      song.sequencer:clone_range( sid , sid - 7 )
    end
    song.selected_sequence_index = sid + 8
    song.sequencer:sort() --sort sequence
    renoise.app():show_status( "GT16-Colors, AMIC:  previous 8 patterns cloned." )
    else
    renoise.app():show_status( "⚠ GT16-Colors, AMIC:  please, select the last block pattern to clone x8!" )
  end
end


--- --- ---
-- CHANNEL 03
--- --- ---
function amic_CH03_1A() --DELETE PATTERN
  local song = renoise.song()
  local ssid = song.selected_sequence_index
  --print ("ssid: ", ssid)
  song.sequencer:delete_sequence_at( ssid )
end

function amic_CH03_2A() --CLEAR SELECTED PATTERN--OK!
  local song = renoise.song()
  song.selected_pattern:clear()
end

function amic_CH03_3A() --CLEAR ALL PARAMETERS OF TRACK IN SELECTED PATTERN--OK!
  local song = renoise.song()
  song.selected_pattern_track:clear()
end
--- ---
function amic_CH03_4A() --INSERT METRONOME AND MORE -------------------------REVIEW!!!
  local song, app = renoise.song(), renoise.app()
  local sid0, sin0 = song.selected_track_index, song.selected_instrument_index --initial track and instrument slot
  if #song.instruments < 255  then
    song:insert_track_at(song.sequencer_track_count + 1) --insert last new track 
    song.selected_track_index = song.sequencer_track_count --select last track
    local sid = song.selected_track_index
    song.tracks[sid].name = "Metronome" --rename metronome
    song.tracks[sid].color = {00,00,00} --change color track
    song.tracks[sid].color_blend = 50 --change color blend track
    song.tracks[sid].volume_column_visible = F --hide volume column
    song.tracks[sid].visible_effect_columns = 0 --hide visible effect column
    --print( "n-instr-max: ", renoise.Song.MAX_NUMBER_OF_INSTRUMENTS ) -- =255
    --print( "n-inst-aval: ", #renoise.song().instruments )
    song.selected_instrument_index = #song.instruments --jump last slot available in instrument box (1-255)
    song:insert_instrument_at(#song.instruments) --insert instrument in last slot available
    app:load_instrument("xrni/metronome.xrni") --insert Metronome XRNI
    for i = 1, #song.sequencer.pattern_sequence, 1 do
      local pattern = song:pattern( i )
      pattern.number_of_lines = 96 --change LINES per pattern
      local note_column = pattern:track(sid):line(1):note_column(1)
      note_column.note_value = 48 --(0-119, 120=Off, 121=Empty) --C-4
      --print( "n-inst-aval: ", #renoise.song().instruments )
      note_column.instrument_value = #song.instruments - 2 --(0-254, 255==Empty)
      local note_column = pattern:track(sid):line(25):note_column(1)
      note_column.note_value = 48 --C-4
      note_column.instrument_value = #song.instruments - 2
      local note_column = pattern:track(sid):line(49):note_column(1)
      note_column.note_value = 48 --C-4
      note_column.instrument_value = #song.instruments - 2
      local note_column = pattern:track(sid):line(73):note_column(1)
      note_column.note_value = 50 --D-4
      note_column.instrument_value = #song.instruments - 2
    end    
    song.selected_track_index = sid0 --return initial track
    song.selected_instrument_index = sin0 --return initial instrument slot
    song.transport.bpm = 176 --BPM (32-999)
    song.transport.lpb = 8 --LPB (1-256)
    song.transport.metronome_enabled = false --metronome off
    app:show_status( "GT16-Colors, AMIC:  Metronome Inserted in last instrument slot." ) --status
  else
    app:show_status( "⚠ GT16-Colors, AMIC:  you are 255 slots used. Please, delete a instrument slot to insert Metronome!" ) --status
  end
end

function amic_CH03_5B() --INSERT THEME
  --renoise.app():load_theme(filename) --insert theme
end

function amic_CH03_6B()
end

function amic_CH03_7B()
end

function amic_CH03_8B()
end

function amic_CH03_9M()
end
--- --- ---
-- CHANNEL 04
--- --- ---
function amic_CH04_1A(i, nm, cl, cb) --CLONE GROUP (EXCEPT NOTES)
--[[
  local song, app = renoise.song(), renoise.app()
  --if ( song.selected_track_index == renoise.Track.TRACK_TYPE_GROUP ) then  --if is a group then
    --print(": ", )
    --song.tracks[song.selected_track_index].group_parent -- Returns most immediate group parent or nil if not in a group.(object)
    --print(": ", song.tracks[song.selected_track_index].members[1] )
    local sid = song.selected_track_index
    local ssid = song.tracks[ song.selected_track_index ]
    i = #ssid.members
    print ( "i:", i )
    print ( "sid:", sid )
    -- -- --
    nm = ssid.name            print ( "nm:", nm )
    cl = ssid.color           print ( "cl:", cl )
    cb = ssid.color_blend     print ( "cb" , cb )
    -- -- --
   
    -- song.insert_track_index(sid)
    -- else
    -- app:show_status( "⚠ GT16-Colors, AMIC:  please, select before a group!" ) --status
  --end
]]
end

function amic_CH04_2A(a)
  local song = renoise.song()
  a = 10
  --[ repeat loop execution --]
  repeat
    print("value of a:", a)
    a = a + 1
    until( a > 15 )
end

function amic_CH04_3A()
  for var=0, 5, 1 do
     print( var .. "\n" )
  end
end

function amic_CH04_4A() --This loop will stop itself after 1.5 seconds. Use a clock
--[[
  local starttime = os.clock()
  print("I'm about to spam you horribly for 1.5 seconds")
  while os.clock() - starttime < 1.5 do
  print("SPAM!")
  end
  print("All done :P")
]]
end

function amic_CH04_5B(song, a)--repeat x4 with "repeat until"
  song = renoise.song()
  a = 1
  repeat
    song:insert_track_at(song.selected_track_index)
    a = a + 1
  until a > 4
end

function amic_CH04_6B(song, a)--repeat x4 with "for do"
  song = renoise.song()
  a = 4
  for i = 1, a, 1 do --or-- for i = 1, a do
    song:insert_track_at(song.selected_track_index)
  end
end

function amic_CH04_7B()
  local mytable = {key1 = "value1", key2 = "value2", key3 = "value3"}
  for key, value in pairs(mytable) do
    print(key, value)
  end
end

function amic_CH04_8B()
  local mytable = {"one", "two", "three"}
  for i, v in ipairs(mytable) do
    print(i, v)
  end
end

function amic_CH04_9M(m, nmg, clg, cbg, nmt, clt, cbt, ncl, vol, pan, dly, sfx, fxt )-- CLONE TRACK OR GROUP WITH A LEVEL
  --[[
  renoise.Track.TRACK_TYPE_SEQUENCER
  renoise.Track.TRACK_TYPE_GROUP
  renoise.Track.TRACK_TYPE_MASTER
  renoise.Track.TRACK_TYPE_SEND
  ]]

  local song, app = renoise.song(), renoise.app()
  local sid = song.selected_track_index
  print ( "sid:", sid )
  local ssid = song.tracks[ song.selected_track_index ]

  if (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then --IF GROUP
    m = #ssid.members
    print ( "sid:", sid )
    print ( "m:", m )
    nmg = ssid.name            print ( "nmg:" , nmg )
    clg = ssid.color           print ( "clg:" , clg )
    cbg = ssid.color_blend     print ( "cbg:" , cbg )
    song:insert_group_at( sid + 1 )    

    local ssid = song.tracks[ sid + 1]
    ssid.name = nmg.." Clone"
    ssid.color = clg
    ssid.color_blend = cbg
    song.selected_track_index = sid - m -- jump first track son

    for i = 1, m do --or-- for i = 1, a do
      local ssid = song.tracks[ song.selected_track_index ]
      nmt = ssid.name            print ( "nmt-son:" , nmt )
      clt = ssid.color           print ( "clt-son:" , clt )
      cbt = ssid.color_blend     print ( "cbt-son:" , cbt )
      --- ---
      ncl = ssid.visible_note_columns           print ( "ncl:" , ncl )
      vol = ssid.volume_column_visible          print ( "vol:" , vol )
      pan = ssid.panning_column_visible         print ( "pan:" , pan )
      dly = ssid.delay_column_visible           print ( "dly:" , dly )
      sfx = ssid.sample_effects_column_visible  print ( "sfx:" , sfx )
      fxt = ssid.visible_effect_columns         print ( "fxt:" , fxt )
      if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) then
        song:insert_track_at(song.selected_track_index + m + 1 )
        print ( "m:", m )
        local ssid = song.tracks[ song.selected_track_index + m + 1 ]
        ssid.name = nmt.." Clone"
        ssid.color = clt
        ssid.color_blend = cbt
        --- ---
        ssid.visible_note_columns = ncl
        ssid.volume_column_visible = vol
        ssid.panning_column_visible = pan
        ssid.delay_column_visible = dly
        ssid.sample_effects_column_visible = sfx
        ssid.visible_effect_columns = fxt
        song.selected_track_index = song.selected_track_index + 1
      end
      --- ---
      --if (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then
      --  song:insert_group_at(song.selected_track_index + m + 1 )
      --  local ssid = song.tracks[ song.selected_track_index + m + 1 ]
        --ssid.name = nmt.." Clone"
        --ssid.color = clt
        --ssid.color_blend = cbt
      --end
    end

    song.selected_track_index = song.selected_track_index + m + 1 --jump new group

    for i = 1, m do
      local sid2 = song.selected_track_index
      song:add_track_to_group( sid2 - m , sid2 ) 
    end

  else
    --content else
  end
  --- --- ---
  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) then --IF TRACK

    --[[ -- 9 parameters
        name = "MY TRACK",
        color = { 0xFF,0x00,0x00 },
        color_blend = 40,
        visible_note_columns = 1,
        volume_column_visible = true,
        panning_column_visible = false,
        delay_column_visible = false,
        sample_effects_column_visible = false,
        visible_effect_columns = 0
      ]]

    nmt = ssid.name                           print ( "nmt:" , nmt )
    clt = ssid.color                          print ( "clt:" , clt )
    cbt = ssid.color_blend                    print ( "cbt:" , cbt )
    --- ---
    ncl = ssid.visible_note_columns           print ( "ncl:" , ncl )
    vol = ssid.volume_column_visible          print ( "vol:" , vol )
    pan = ssid.panning_column_visible         print ( "pan:" , pan )
    dly = ssid.delay_column_visible           print ( "dly:" , dly )
    sfx = ssid.sample_effects_column_visible  print ( "sfx:" , sfx )
    fxt = ssid.visible_effect_columns         print ( "fxt:" , fxt )
    
    song:insert_track_at(sid + 1)
    local ssid = song.tracks[ sid + 1]
    ssid.name = nmt.." Clone"
    ssid.color = clt
    ssid.color_blend = cbt
    --- ---
    ssid.visible_note_columns = ncl
    ssid.volume_column_visible = vol
    ssid.panning_column_visible = pan
    ssid.delay_column_visible = dly
    ssid.sample_effects_column_visible = sfx
    ssid.visible_effect_columns = fxt
  
    song.selected_track_index = sid + 1
  else
   --content else
  end
end
-- Copy contents from other pattern tracks, including automation when possible.
-- renoise.song().patterns[].tracks[]:copy_from(
-- other renoise.PatternTrack object)


--- --- ---
-- CHANNEL 05
--- --- ---
function amic_CH05_1A( song, spi, sti, sli, snci, sii ) --Select a block in track. And copy??
  song = renoise.song()
  spi, sti, sli, snci, sii = song.selected_pattern_index, song.selected_track_index, song.selected_line_index, song.selected_note_column_index, song.selected_instrument_index
  song.selection_in_pattern = { start_line = sli, start_track = sti, end_line = sli + 16, end_track = sti } 
end


function repeat_amic_CH05_2A(release) --Jump line empty
  if not release then
    if renoise.tool():has_timer(repeat_amic_CH05_2A) then
      amic_CH05_2A()
      -- switch to fast timer on second run
      renoise.tool():remove_timer(repeat_amic_CH05_2A)
      renoise.tool():add_timer(amic_CH05_2A, 40)
    else
      -- first run
      amic_CH05_2A()
      renoise.tool():add_timer(repeat_amic_CH05_2A, 400)
    end
  else -- release all timers
    if renoise.tool():has_timer(repeat_amic_CH05_2A) then
      renoise.tool():remove_timer(repeat_amic_CH05_2A)
    elseif renoise.tool():has_timer(amic_CH05_2A) then
      renoise.tool():remove_timer(amic_CH05_2A)
    end
  end  
end
function amic_CH05_2A( song, spi, sti, sli, snci, sii  )
  --renoise.song().patterns[].tracks[].lines[].note_columns[].is_empty
  --renoise.song().patterns[].tracks[].lines[].note_columns[].volume_value --127
  song = renoise.song()
  spi, sti, sli, snci, sii = song.selected_pattern_index, song.selected_track_index, song.selected_line_index, song.selected_note_column_index, song.selected_instrument_index
  if song.patterns[ spi ].tracks[ sti ].lines[ sli ].note_columns[ snci ].is_empty == true then
    song.selected_line_index = sli + 1
  else
    song.patterns[ spi ].tracks[ sti ].lines[ sli ].note_columns[ snci ].volume_value = 127
    song.selected_line_index = sli + 1
  end
end


function amic_CH05_3A( song, spi, sti, sli, snci, sii ) --Select a block in track. And copy??
  song = renoise.song()
  spi, sti, sli, snci, sii = song.selected_pattern_index, song.selected_track_index, song.selected_line_index, song.selected_note_column_index, song.selected_instrument_index
  song.selection_in_pattern = { start_line = sli, start_track = sti, end_line = sli + 16, end_track = sti } 
end

-----------------------
function amic_CH05_4A() --local function copy_block_to_cursor()
  local song = renoise.song()
  local selection = song.selection_in_pattern
  local selection_data = { --the table of selection in pattern editor
    start_line = selection.start_line,
    end_line = selection.end_line,
    track_index = selection.start_track,
    ncol_index = selection.start_column,
    --range = selection.end_line - selection.start_line
  }
  local patterntrack = song.selected_pattern:track(selection_data.track_index) --origin patterntrack
  local patterntrack_dest = song.selected_pattern_track --destiny patterntrack_dest
  local offset = song.selected_line_index - selection_data.start_line -- destination index minus source index
  for pos = selection_data.start_line, selection_data.end_line do
    local src_ncol = patterntrack:line(pos):note_column(selection_data.ncol_index)
    local dest_ncol = patterntrack_dest:line(pos + offset):note_column(song.selected_note_column_index)
    dest_ncol:copy_from(src_ncol)
  end 
end

--renoise.song().selected_pattern_track
--renoise.song():pattern(renoise.song().selected_pattern_index):track(renoise.song().selected_track_index)

-----------------------

function amic_CH05_5B()
  local rs = renoise.song()
  local sp = rs.selected_pattern
  local st = sp:track(1)
  local sl = st:line(1)
  
  local dp = rs.selected_pattern
  local dt = dp:track(2)
  local dl = dt:line(1)
  dl:copy_from(sl)
end

function amic_CH05_6B( song, a, b )
  song = renoise.song()
  a = song.selected_pattern:track(1):line(1)
  b = song.selected_pattern:track(2):line(1)
  b:copy_from(a)
end

function amic_CH05_7B(song, spi, sti, sli, snci, sii, a, b)
--[[
  song = renoise.song()
  spi, sti, sli, snci, sii = song.selected_pattern_index, song.selected_track_index, song.selected_line_index, song.selected_note_column_index, song.selected_instrument_index
  a = { start_line = sli, start_track = sti, end_line = sli + 16, end_track = sti } 
  b = { start_line = sli, start_track = sti + 1, end_line = sli + 16, end_track = sti + 1 }  --song.selected_pattern:track(2):line(1)
  b:copy_from(a)
]]
end

function amic_CH05_8B()

local selected_track = renoise.song().selected_track_index

local function copy_line(from_line, to_line)
 renoise.song().selected_pattern.tracks[selected_track].lines[to_line]:copy_from(renoise.song().selected_pattern.tracks[selected_track].lines[from_line])
end

local function copy_first_quarter(pattern, track)
 local source_range = renoise.song().selected_pattern.number_of_lines / 4
 for i=1, source_range, 1 do
  copy_line(i, i+source_range)
  copy_line(i, i+source_range*2)
  copy_line(i, i+source_range*3)
 end
end

copy_first_quarter(renoise.song().selected_pattern_index, selected_track)

end

function amic_CH05_9M()
end
--- --- ---
-- CHANNEL 06
--- --- ---
function amic_CH06_1A()
  local song = renoise.song()
  local selection = song.selection_in_pattern
  local selection_data = { --the table of selection in pattern editor
    start_line = selection.start_line,
    end_line = selection.end_line,
    track_index = selection.start_track,
    ncol_index = selection.start_column,
    --range = selection.end_line - selection.start_line
  }
  local patterntrack = song.selected_pattern:track(selection_data.track_index) --origin patterntrack
  local patterntrack_dest = song.selected_pattern_track --destiny patterntrack_dest
  local offset = song.selected_line_index - selection_data.start_line -- destination index minus source index
  for pos = selection_data.start_line, selection_data.end_line do
    local src_ncol = patterntrack:line(pos):note_column(selection_data.ncol_index)
    local dest_ncol = patterntrack_dest:line(pos + offset):note_column(song.selected_note_column_index)
    dest_ncol:copy_from(src_ncol)
  end 
end

function amic_CH06_2A()
  local song = renoise.song()
  local selection = song.selection_in_pattern
  local table = { 
    start_line  = selection.start_line,
    end_line    = selection.end_line,
    track_index = selection.start_track,
    ncol_index  = selection.start_column,
  }
  return table
end

function amic_CH06_3A()
 local song = renoise.song()
 local y = song.selected_pattern_track:line(song.selected_line_index):note_column(song.selected_note_column_index)
 y = amic_CH06_2A()
end

function amic_CH06_4A()
end

function amic_CH06_5B()
end

function amic_CH06_6B()
end

function amic_CH06_7B()
end

function amic_CH06_8B()
end

function amic_CH06_9M()
end
--- --- ---
-- CHANNEL 07
--- --- ---
function amic_CH07_1A()
end

function amic_CH07_2A()
end

function amic_CH07_3A()
end

function amic_CH07_4A()
end

function amic_CH07_5B()
end

function amic_CH07_6B()
end

function amic_CH07_7B()
end

function amic_CH07_8B()
end

function amic_CH07_9M()
end
--- --- ---
-- CHANNEL 08
--- --- ---
function amic_CH08_1A()
end

function amic_CH08_2A()
end

function amic_CH08_3A()
end

function amic_CH08_4A()
end

function amic_CH08_5B()
end

function amic_CH08_6B()
end

function amic_CH08_7B()
end

function amic_CH08_8B()
end

function amic_CH08_9M()
end
--- --- ---
-- CHANNEL 09
--- --- ---
function amic_CH09_1A()
end

function amic_CH09_2A()
end

function amic_CH09_3A()
end

function amic_CH09_4A()
end

function amic_CH09_5B()
end

function amic_CH09_6B()
end

function amic_CH09_7B()
end

function amic_CH09_8B()
end

function amic_CH09_9M()
end
--- --- ---
-- CHANNEL 10
--- --- ---
function amic_CH10_1A()
end

function amic_CH10_2A()
end

function amic_CH10_3A()
end

function amic_CH10_4A()
end

function amic_CH10_5B()
end

function amic_CH10_6B()
end

function amic_CH10_7B()
end

function amic_CH10_8B()
end

function amic_CH10_9M()
end
--- --- ---
-- CHANNEL 11
--- --- ---
function amic_CH11_1A()
end

function amic_CH11_2A()
end

function amic_CH11_3A()
end

function amic_CH11_4A()
end

function amic_CH11_5B()
end

function amic_CH11_6B()
end

function amic_CH11_7B()
end

function amic_CH11_8B()
end

function amic_CH11_9M()
end
--- --- ---
-- CHANNEL 12
--- --- ---
function amic_CH12_1A()
end

function amic_CH12_2A()
end

function amic_CH12_3A()
end

function amic_CH12_4A()
end

function amic_CH12_5B()
end

function amic_CH12_6B()
end

function amic_CH12_7B()
end

function amic_CH12_8B()
end

function amic_CH12_9M()
end
--- --- ---
-- CHANNEL 13
--- --- ---
function amic_CH13_1A()
end

function amic_CH13_2A()
end

function amic_CH13_3A()
end

function amic_CH13_4A()
end

function amic_CH13_5B()
end

function amic_CH13_6B()
end

function amic_CH13_7B()
end

function amic_CH13_8B()
end

function amic_CH13_9M()
end
--- --- ---
-- CHANNEL 14
--- --- ---
function amic_CH14_1A()
end

function amic_CH14_2A()
end

function amic_CH14_3A()
end

function amic_CH14_4A()
end

function amic_CH14_5B()
end

function amic_CH14_6B()
end

function amic_CH14_7B()
end

function amic_CH14_8B()
end

function amic_CH14_9M()
end
--- --- ---
-- CHANNEL 15
--- --- ---
function amic_CH15_1A()
end

function amic_CH15_2A()
end

function amic_CH15_3A()
end

function amic_CH15_4A()
end

function amic_CH15_5B()
end

function amic_CH15_6B()
end

function amic_CH15_7B()
end

function amic_CH15_8B()
end

function amic_CH15_9M()
end
--- --- ---
-- CHANNEL 16
--- --- ---
function amic_CH16_1A()--SHOW & FOCUS PATTERN EDITOR
  local app = renoise.app()
  app.window.active_middle_frame = renoise.ApplicationWindow.MIDDLE_FRAME_PATTERN_EDITOR
end

function amic_CH16_2A()--SHOW & FOCUS MIXER
  local app = renoise.app()
  app.window.active_middle_frame = renoise.ApplicationWindow.MIDDLE_FRAME_MIXER
end

function amic_CH16_3A( message )--SHOW & FOCUS MATRIX MAXIMICED
  --local app = renoise.app()
  --app.window.pattern_matrix_is_visible = boolean_message_value( message, app.window.pattern_matrix_is_visible)
end

function amic_CH16_4A()--SWOW & FOCUS PLUGIN EDITOR
  local app = renoise.app()
  app.window.active_middle_frame = renoise.ApplicationWindow.MIDDLE_FRAME_INSTRUMENT_PLUGIN_EDITOR
end

function amic_CH16_5B()
end

function amic_CH16_6B()
end

function amic_CH16_7B()
end

function amic_CH16_8B()--PLAY SONG
  local song = renoise.song()
  local play_mode = renoise.Transport.PLAYMODE_RESTART_PATTERN
  song.transport:start(play_mode)
end

function amic_CH16_9M()--STOP SONG
  local song = renoise.song()
  song.transport:stop()
end


--------------------------------------------------------------------------------
-- GUI - TOOL 02
--------------------------------------------------------------------------------
AMIC =
vb:column {
  --- ---
  vb:horizontal_aligner {
    vb:horizontal_aligner {
      mode = 'center',
      width = 392,
      vb:text { font = 'bold', text = '♆ AMIC: Aditional MIDI Input Control' },
      vb:text { text = '   v1.0b' }
    },
    vb:horizontal_aligner {
      mode = 'left',
      width = 216,
      vb:text { text = 'Channel Group ' },
      swi_cl_abmenu, 
    },
    vb:horizontal_aligner {
      mode = 'right',
      width = 69,
      vb:text { text = '+ info ' },
      checkbox_amic_info
    }
  },
  vb:column {
    id = 'abtab_t',
    visible = true,
------------------------------------------------------------------------------- SWITH CHANNEL GROUP 01-08
    vb:horizontal_aligner { height = 4 },
    vb:horizontal_aligner {
      vb:column {
        width = 368,
        vb:horizontal_aligner {
          mode = 'center',
          vb:text { text = 'Channel Group 01-08' },
        }
      },
      vb:column {
        width = 200,
        vb:horizontal_aligner {
          vb:text { text = 'Selector 01-08 ' },
          checkbox_amic_01, checkbox_amic_02, checkbox_amic_03, checkbox_amic_04,
          vb:horizontal_aligner { width = 4 },
          checkbox_amic_05, checkbox_amic_06, checkbox_amic_07, checkbox_amic_08
        }
      }
    },
    vb:horizontal_aligner { height = 4 },
-------------------------------------------------------------------------------
    --- ---
    --A CH01
    --- ---
    vb:column {
      id = 'cbox_amic_01_f',
      visible = false,
    },  
    vb:column {
      id = 'cbox_amic_01_t',
      visible = true,
      vb:horizontal_aligner {
        --- ---
        vb:button {
          color = CR.ROW01_X,
          text = '1 A',
          id = 'CH01_1A',
          tooltip = TP.CH01_1A,
          midi_mapping = MR.CH01_1A,
          height = 24,
          width = 68,
          notifier = function()amic_CH01_1A() end
        },
        --- ---
        vb:button {
          color = CR.ROW01_X,
          text = '2 A',
          id = 'CH01_2A',
          tooltip = TP.CH01_2A,
          midi_mapping = MR.CH01_2A,
          height = 24,
          width = 68,
          notifier = function()amic_CH01_2A() end
        },
        --- ---
        vb:button {
          color = CR.ROW01_X,
          text = '3 A',
          id = 'CH01_3A',
          tooltip = TP.CH01_3A,
          midi_mapping = MR.CH01_3A,
          height = 24,
          width = 68,
          notifier = function()amic_CH01_3A() end
        },
        --- ---
        vb:button {
          color = CR.ROW01_X,
          text = '4 A',
          id = 'CH01_4A',
          tooltip = TP.CH01_4A,
          midi_mapping = MR.CH01_4A,
          height = 24,
          width = 68,
          notifier = function()amic_CH01_4A() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW01_Y,
          text = '5 B',
          id = 'CH01_5B',
          tooltip = TP.CH01_5B,
          midi_mapping = MR.CH01_5B,
          height = 24,
          width = 68,
          notifier = function()amic_CH01_5B() end
        },
        --- ---
        vb:button {
          color = CR.ROW01_Y,
          text = '6 B',
          id = 'CH01_6B',
          tooltip = TP.CH01_6B,
          midi_mapping = MR.CH01_6B,
          height = 24,
          width = 68,
          notifier = function()amic_CH01_6B() end
        },
        --- ---
        vb:button {
          color = CR.ROW01_Y,
          text = '7 B',
          id = 'CH01_7B',
          tooltip = TP.CH01_7B,
          midi_mapping = MR.CH01_7B,
          height = 24,
          width = 68,
          notifier = function()amic_CH01_7B() end
        },
        --- ---
        vb:button {
          color = CR.ROW01_Y,
          text = '8 B',
          id = 'CH01_8B',
          tooltip = TP.CH01_8B,
          midi_mapping = MR.CH01_8B,
          height = 24,
          width = 68,
          notifier = function()amic_CH01_8B() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW01_Z,
          text = '9 M',
          id = 'CH01_9M',
          tooltip = TP.CH01_9M,
          midi_mapping = MR.CH01_9M,
          height = 24,
          width = 68,
          notifier = function()amic_CH01_9M() end
        },
        --- ---
        vb:horizontal_aligner {
          margin = 3,
          width = 58,
          vb:text { text = ' Ch01 '},
          checkbox_amic_ch01
        }
      },
      -- -- --
      vb:column {
        id ='cbox_amic_ch01_f',
        visible = false,
      }, 
      vb:column {
        id = 'cbox_amic_ch01_t',
        visible = false,
        width = 640,
        vb:horizontal_aligner { height = 2 },
        vb:horizontal_aligner {
          vb:column { width = 4},
          vb:column {
            vb:button {
              active = false,
              color = CR.ROW01_X,
              height = 60,
              width = 8,
            }
          },
          vb:column { width = 320, txt_ch01A },
          vb:vertical_aligner {
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW01_Y,
                height = 58,
                width = 8,
              }
            },
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW01_Z,
                height = 18,
                width = 8,
              }
            }
          },
          vb:column { width = 320, txt_ch01B }
        },
        vb:horizontal_aligner { height = 8 },
      }
    },
    --- ---
    --A CH02
    --- ---
    vb:column {
      id = 'cbox_amic_02_f',
      visible = false,
    },  
    vb:column {
      id = 'cbox_amic_02_t',
      visible = true,
      vb:horizontal_aligner {
        --- ---
        vb:button {
          color = CR.ROW02_X,
          text = '1 A',
          id = 'CH02_1A',
          tooltip = TP.CH02_1A,
          midi_mapping = MR.CH02_1A,
          height = 24,
          width = 68,
          notifier = function()amic_CH02_1A() end
        },
        --- ---
        vb:button {
          color = CR.ROW02_X,
          text = '2 A',
          id = 'CH02_2A',
          tooltip = TP.CH02_2A,
          midi_mapping = MR.CH02_2A,
          height = 24,
          width = 68,
          notifier = function()amic_CH02_2A() end
        },
        --- ---
        vb:button {
          color = CR.ROW02_X,
          text = '3 A',
          id = 'CH02_3A',
          tooltip = TP.CH02_3A,
          midi_mapping = MR.CH02_3A,
          height = 24,
          width = 68,
          notifier = function()amic_CH02_3A() end
        },
        --- ---
        vb:button {
          color = CR.ROW02_X,
          text = '4 A',
          id = 'CH02_4A',
          tooltip = TP.CH02_4A,
          midi_mapping = MR.CH02_4A,
          height = 24,
          width = 68,
          notifier = function()amic_CH02_4A() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW02_Y,
          text = '5 B',
          id = 'CH02_5B',
          tooltip = TP.CH02_5B,
          midi_mapping = MR.CH02_5B,
          height = 24,
          width = 68,
          notifier = function()amic_CH02_5B() end
        },
        --- ---
        vb:button {
          color = CR.ROW02_Y,
          text = '6 B',
          id = 'CH02_6B',
          tooltip = TP.CH02_6B,
          midi_mapping = MR.CH02_6B,
          height = 24,
          width = 68,
          notifier = function()amic_CH02_6B() end
        },
        --- ---
        vb:button {
          color = CR.ROW02_Y,
          text = '7 B',
          id = 'CH02_7B',
          tooltip = TP.CH02_7B,
          midi_mapping = MR.CH02_7B,
          height = 24,
          width = 68,
          notifier = function()amic_CH02_7B() end
        },
        --- ---
        vb:button {
          color = CR.ROW02_Y,
          text = '8 B',
          id = 'CH02_8B',
          tooltip = TP.CH02_8B,
          midi_mapping = MR.CH02_8B,
          height = 24,
          width = 68,
          notifier = function()amic_CH02_8B() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW02_Z,
          text = '9 M',
          id = 'CH02_9M',
          tooltip = TP.CH02_9M,
          midi_mapping = MR.CH02_9M,
          height = 24,
          width = 68,
          notifier = function()amic_CH02_9M() end
        },
        --- ---
        vb:horizontal_aligner {
          margin = 3,
          width = 58,
          vb:text { text = ' Ch02 '},
          checkbox_amic_ch02
        }
      },
      -- -- --
      vb:column {
        id ='cbox_amic_ch02_f',
        visible = false,
      },  
      vb:column {
        id = 'cbox_amic_ch02_t',
        visible = false,
        width = 640,
        vb:horizontal_aligner { height = 2 },
        vb:horizontal_aligner {
          vb:column { width = 4},
          vb:column {
            vb:button {
              active = false,
              color = CR.ROW02_X,
              height = 60,
              width = 8,
            }
          },
          vb:column { width = 320, txt_ch02A },
          vb:vertical_aligner {
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW02_Y,
                height = 58,
                width = 8,
              }
            },
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW02_Z,
                height = 18,
                width = 8,
              }
            }
          },
          vb:column { width = 320, txt_ch02B }
        },
        vb:horizontal_aligner { height = 8 },
      }
    },
    --- ---
    --A CH03
    --- ---  
    vb:column {
      id = 'cbox_amic_03_f',
      visible = false,
    },  
    vb:column {
      id = 'cbox_amic_03_t',
      visible = true,
      vb:horizontal_aligner {
        --- ---
        vb:button {
          color = CR.ROW03_X,
          text = '1 A',
          id = 'CH03_1A',
          tooltip = TP.CH03_1A,
          midi_mapping = MR.CH03_1A,
          height = 24,
          width = 68,
          notifier = function()amic_CH03_1A() end
        },
        --- ---
        vb:button {
          color = CR.ROW03_X,
          text = '2 A',
          id = 'CH03_2A',
          tooltip = TP.CH03_2A,
          midi_mapping = MR.CH03_2A,
          height = 24,
          width = 68,
          notifier = function()amic_CH03_2A() end
        },
        --- ---
        vb:button {
          color = CR.ROW03_X,
          text = '3 A',
          id = 'CH03_3A',
          tooltip = TP.CH03_3A,
          midi_mapping = MR.CH03_3A,
          height = 24,
          width = 68,
          notifier = function()amic_CH03_3A() end
        },
        --- ---
        vb:button {
          color = CR.ROW03_X,
          text = '4 A',
          id = 'CH03_4A',
          tooltip = TP.CH03_4A,
          midi_mapping = MR.CH03_4A,
          height = 24,
          width = 68,
          notifier = function()amic_CH03_4A() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW03_Y,
          text = '5 B',
          id = 'CH03_5B',
          tooltip = TP.CH03_5B,
          midi_mapping = MR.CH03_5B,
          height = 24,
          width = 68,
          notifier = function()amic_CH03_5B() end
        },
        --- ---
        vb:button {
          color = CR.ROW03_Y,
          text = '6 B',
          id = 'CH03_6B',
          tooltip = TP.CH03_6B,
          midi_mapping = MR.CH03_6B,
          height = 24,
          width = 68,
          notifier = function()amic_CH03_6B() end
        },
        --- ---
        vb:button {
          color = CR.ROW03_Y,
          text = '7 B',
          id = 'CH03_7B',
          tooltip = TP.CH03_7B,
          midi_mapping = MR.CH03_7B,
          height = 24,
          width = 68,
          notifier = function()amic_CH03_7B() end
        },
        --- ---
        vb:button {
          color = CR.ROW03_Y,
          text = '8 B',
          id = 'CH03_8B',
          tooltip = TP.CH03_8B,
          midi_mapping = MR.CH03_8B,
          height = 24,
          width = 68,
          notifier = function()amic_CH03_8B() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW03_Z,
          text = '9 M',
          id = 'CH03_9M',
          tooltip = TP.CH03_9M,
          midi_mapping = MR.CH03_9M,
          height = 24,
          width = 68,
          notifier = function()amic_CH03_9M() end
        },
        --- ---
        vb:horizontal_aligner {
          margin = 3,
          width = 58,
          vb:text { text = ' Ch03 '},
          checkbox_amic_ch03
        }
      },
      -- -- --
      vb:column {
        id ='cbox_amic_ch03_f',
        visible = false,
      },  
      vb:column {
        id = 'cbox_amic_ch03_t',
        visible = false,
        width = 640,
        vb:horizontal_aligner { height = 2 },
        vb:horizontal_aligner {
          vb:column { width = 4},
          vb:column {
            vb:button {
              active = false,
              color = CR.ROW03_X,
              height = 60,
              width = 8,
            }
          },
          vb:column { width = 320, txt_ch03A },
          vb:vertical_aligner {
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW03_Y,
                height = 58,
                width = 8,
              }
            },
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW03_Z,
                height = 18,
                width = 8,
              }
            }
          },
          vb:column { width = 320, txt_ch03B }
        },
        vb:horizontal_aligner { height = 8 },
      }
    },
    --- ---
    --A CH04
    --- ---
    vb:column {
      id = 'cbox_amic_04_f',
      visible = false,
    },  
    vb:column {
      id = 'cbox_amic_04_t',
      visible = true,
      vb:horizontal_aligner {
        --- ---
        vb:button {
          color = CR.ROW04_X,
          text = '1 A',
          id = 'CH04_1A',
          tooltip = TP.CH04_1A,
          midi_mapping = MR.CH04_1A,
          height = 24,
          width = 68,
          notifier = function()amic_CH04_1A() end
        },
        --- ---
        vb:button {
          color = CR.ROW04_X,
          text = '2 A',
          id = 'CH04_2A',
          tooltip = TP.CH04_2A,
          midi_mapping = MR.CH04_2A,
          height = 24,
          width = 68,
          notifier = function()amic_CH04_2A() end
        },
        --- ---
        vb:button {
          color = CR.ROW04_X,
          text = '3 A',
          id = 'CH04_3A',
          tooltip = TP.CH04_3A,
          midi_mapping = MR.CH04_3A,
          height = 24,
          width = 68,
          notifier = function()amic_CH04_3A() end
        },
        --- ---
        vb:button {
          color = CR.ROW04_X,
          text = '4 A',
          id = 'CH04_4A',
          tooltip = TP.CH04_4A,
          midi_mapping = MR.CH04_4A,
          height = 24,
          width = 68,
          notifier = function()amic_CH04_4A() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW04_Y,
          text = '5 B',
          id = 'CH04_5B',
          tooltip = TP.CH04_5B,
          midi_mapping = MR.CH04_5B,
          height = 24,
          width = 68,
          notifier = function()amic_CH04_5B() end
        },
        --- ---
        vb:button {
          color = CR.ROW04_Y,
          text = '6 B',
          id = 'CH04_6B',
          tooltip = TP.CH04_6B,
          midi_mapping = MR.CH04_6B,
          height = 24,
          width = 68,
          notifier = function()amic_CH04_6B() end
        },
        --- ---
        vb:button {
          color = CR.ROW04_Y,
          text = '7 B',
          id = 'CH04_7B',
          tooltip = TP.CH04_7B,
          midi_mapping = MR.CH04_7B,
          height = 24,
          width = 68,
          notifier = function()amic_CH04_7B() end
        },
        --- ---
        vb:button {
          color = CR.ROW04_Y,
          text = '8 B',
          id = 'CH04_8B',
          tooltip = TP.CH04_8B,
          midi_mapping = MR.CH04_8B,
          height = 24,
          width = 68,
          notifier = function()amic_CH04_8B() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW04_Z,
          text = '9 M',
          id = 'CH04_9M',
          tooltip = TP.CH04_9M,
          midi_mapping = MR.CH04_9M,
          height = 24,
          width = 68,
          notifier = function()amic_CH04_9M() end
        },
        --- ---
        vb:horizontal_aligner {
          margin = 3,
          width = 58,
          vb:text { text = ' Ch04 '},
          checkbox_amic_ch04
        }
      },
      -- -- --
      vb:column {
        id ='cbox_amic_ch04_f',
        visible = false,
      },  
      vb:column {
        id = 'cbox_amic_ch04_t',
        visible = false,
        width = 640,
        vb:horizontal_aligner { height = 2 },
        vb:horizontal_aligner {
          vb:column { width = 4},
          vb:column {
            vb:button {
              active = false,
              color = CR.ROW04_X,
              height = 60,
              width = 8,
            }
          },
          vb:column { width = 320, txt_ch04A },
          vb:vertical_aligner {
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW04_Y,
                height = 58,
                width = 8,
              }
            },
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW04_Z,
                height = 18,
                width = 8,
              }
            }
          },
          vb:column { width = 320, txt_ch04B }
        },
        vb:horizontal_aligner { height = 8 },
      }
    },
    --- ---
    --A CH05
    --- ---
    vb:column {
      id = 'cbox_amic_05_f',
      visible = false,
    },  
    vb:column {
      id = 'cbox_amic_05_t',
      visible = false,
      vb:horizontal_aligner {
        --- ---
        vb:button {
          color = CR.ROW05_X,
          text = '1 A',
          id = 'CH05_1A',
          tooltip = TP.CH05_1A,
          midi_mapping = MR.CH05_1A,
          height = 24,
          width = 68,
          notifier = function()amic_CH05_1A() end
        },
        --- ---
        vb:button {
          color = CR.ROW05_X,
          text = '2 A',
          id = 'CH05_2A',
          tooltip = TP.CH05_2A,
          midi_mapping = MR.CH05_2A,
          height = 24,
          width = 68,
          --notifier = function()amic_CH05_2A() end,
          pressed =  function() repeat_amic_CH05_2A() end,
          released = function() repeat_amic_CH05_2A(true) end,
        },
        --- ---
        vb:button {
          color = CR.ROW05_X,
          text = '3 A',
          id = 'CH05_3A',
          tooltip = TP.CH05_3A,
          midi_mapping = MR.CH05_3A,
          height = 24,
          width = 68,
          notifier = function()amic_CH05_3A() end
        },
        --- ---
        vb:button {
          color = CR.ROW05_X,
          text = '4 A',
          id = 'CH05_4A',
          tooltip = TP.CH05_4A,
          midi_mapping = MR.CH05_4A,
          height = 24,
          width = 68,
          notifier = function()amic_CH05_4A() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW05_Y,
          text = '5 B',
          id = 'CH05_5B',
          tooltip = TP.CH05_5B,
          midi_mapping = MR.CH05_5B,
          height = 24,
          width = 68,
          notifier = function()amic_CH05_5B() end
        },
        --- ---
        vb:button {
          color = CR.ROW05_Y,
          text = '6 B',
          id = 'CH05_6B',
          tooltip = TP.CH05_6B,
          midi_mapping = MR.CH05_6B,
          height = 24,
          width = 68,
          notifier = function()amic_CH05_6B() end
        },
        --- ---
        vb:button {
          color = CR.ROW05_Y,
          text = '7 B',
          id = 'CH05_7B',
          tooltip = TP.CH05_7B,
          midi_mapping = MR.CH05_7B,
          height = 24,
          width = 68,
          notifier = function()amic_CH05_7B() end
        },
        --- ---
        vb:button {
          color = CR.ROW05_Y,
          text = '8 B',
          id = 'CH05_8B',
          tooltip = TP.CH05_8B,
          midi_mapping = MR.CH05_8B,
          height = 24,
          width = 68,
          notifier = function()amic_CH05_8B() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW05_Z,
          text = '9 M',
          id = 'CH05_9M',
          tooltip = TP.CH05_9M,
          midi_mapping = MR.CH05_9M,
          height = 24,
          width = 68,
          notifier = function()amic_CH05_9M() end
        },
        --- ---
        vb:horizontal_aligner {
          margin = 3,
          width = 58,
          vb:text { text = ' Ch05 '},
          checkbox_amic_ch05
        }
      },
      -- -- --
      vb:column {
        id ='cbox_amic_ch05_f',
        visible = false,
      },  
      vb:column {
        id = 'cbox_amic_ch05_t',
        visible = false,
        width = 640,
        vb:horizontal_aligner { height = 2 },
        vb:horizontal_aligner {
          vb:column { width = 4},
          vb:column {
            vb:button {
              active = false,
              color = CR.ROW05_X,
              height = 60,
              width = 8,
            }
          },
          vb:column { width = 320, txt_ch05A },
          vb:vertical_aligner {
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW05_Y,
                height = 58,
                width = 8,
              }
            },
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW05_Z,
                height = 18,
                width = 8,
              }
            }
          },
          vb:column { width = 320, txt_ch05B }
        },
        vb:horizontal_aligner { height = 8 },
      }
    },
    --- ---
    --A CH06
    --- ---
    vb:column {
      id = 'cbox_amic_06_f',
      visible = false,
    },  
    vb:column {
      id = 'cbox_amic_06_t',
      visible = false,
      vb:horizontal_aligner {
        --- ---
        vb:button {
          color = CR.ROW06_X,
          text = '1 A',
          id = 'CH06_1A',
          tooltip = TP.CH06_1A,
          midi_mapping = MR.CH06_1A,
          height = 24,
          width = 68,
          notifier = function()amic_CH06_1A() end
        },
        --- ---
        vb:button {
          color = CR.ROW06_X,
          text = '2 A',
          id = 'CH06_2A',
          tooltip = TP.CH06_2A,
          midi_mapping = MR.CH06_2A,
          height = 24,
          width = 68,
          notifier = function()amic_CH06_2A() end
        },
        --- ---
        vb:button {
          color = CR.ROW06_X,
          text = '3 A',
          id = 'CH06_3A',
          tooltip = TP.CH06_3A,
          midi_mapping = MR.CH06_3A,
          height = 24,
          width = 68,
          notifier = function()amic_CH06_3A() end
        },
        --- ---
        vb:button {
          color = CR.ROW06_X,
          text = '4 A',
          id = 'CH06_4A',
          tooltip = TP.CH06_4A,
          midi_mapping = MR.CH06_4A,
          height = 24,
          width = 68,
          notifier = function()amic_CH06_4A() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW06_Y,
          text = '5 B',
          id = 'CH06_5B',
          tooltip = TP.CH06_5B,
          midi_mapping = MR.CH06_5B,
          height = 24,
          width = 68,
          notifier = function()amic_CH06_5B() end
        },
        --- ---
        vb:button {
          color = CR.ROW06_Y,
          text = '6 B',
          id = 'CH06_6B',
          tooltip = TP.CH06_6B,
          midi_mapping = MR.CH06_6B,
          height = 24,
          width = 68,
          notifier = function()amic_CH06_6B() end
        },
        --- ---
        vb:button {
          color = CR.ROW06_Y,
          text = '7 B',
          id = 'CH06_7B',
          tooltip = TP.CH06_7B,
          midi_mapping = MR.CH06_7B,
          height = 24,
          width = 68,
          notifier = function()amic_CH06_7B() end
        },
        --- ---
        vb:button {
          color = CR.ROW06_Y,
          text = '8 B',
          id = 'CH06_8B',
          tooltip = TP.CH06_8B,
          midi_mapping = MR.CH06_8B,
          height = 24,
          width = 68,
          notifier = function()amic_CH06_8B() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW06_Z,
          text = '9 M',
          id = 'CH06_9M',
          tooltip = TP.CH06_9M,
          midi_mapping = MR.CH06_9M,
          height = 24,
          width = 68,
          notifier = function()amic_CH06_9M() end
        },
        --- ---
        vb:horizontal_aligner {
          margin = 3,
          width = 58,
          vb:text { text = ' Ch06 '},
          checkbox_amic_ch06
        }
      },
      -- -- --
      vb:column {
        id ='cbox_amic_ch06_f',
        visible = false,
      },  
      vb:column {
        id = 'cbox_amic_ch06_t',
        visible = false,
        width = 640,
        vb:horizontal_aligner { height = 2 },
        vb:horizontal_aligner {
          vb:column { width = 4},
          vb:column {
            vb:button {
              active = false,
              color = CR.ROW06_X,
              height = 60,
              width = 8,
            }
          },
          vb:column { width = 320, txt_ch06A },
          vb:vertical_aligner {
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW06_Y,
                height = 58,
                width = 8,
              }
            },
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW06_Z,
                height = 18,
                width = 8,
              }
            }
          },
          vb:column { width = 320, txt_ch06B }
        },
        vb:horizontal_aligner { height = 8 },
      }
    },
    --- ---
    --A CH07
    --- ---
    vb:column {
      id = 'cbox_amic_07_f',
      visible = false,
    },  
    vb:column {
      id = 'cbox_amic_07_t',
      visible = false,
      vb:horizontal_aligner {
        --- ---
        vb:button {
          color = CR.ROW07_X,
          text = '1 A',
          id = 'CH07_1A',
          tooltip = TP.CH07_1A,
          midi_mapping = MR.CH07_1A,
          height = 24,
          width = 68,
          notifier = function()amic_CH07_1A() end
        },
        --- ---
        vb:button {
          color = CR.ROW07_X,
          text = '2 A',
          id = 'CH07_2A',
          tooltip = TP.CH07_2A,
          midi_mapping = MR.CH07_2A,
          height = 24,
          width = 68,
          notifier = function()amic_CH07_2A() end
        },
        --- ---
        vb:button {
          color = CR.ROW07_X,
          text = '3 A',
          id = 'CH07_3A',
          tooltip = TP.CH07_3A,
          midi_mapping = MR.CH07_3A,
          height = 24,
          width = 68,
          notifier = function()amic_CH07_3A() end
        },
        --- ---
        vb:button {
          color = CR.ROW07_X,
          text = '4 A',
          id = 'CH07_4A',
          tooltip = TP.CH07_4A,
          midi_mapping = MR.CH07_4A,
          height = 24,
          width = 68,
          notifier = function()amic_CH07_4A() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW07_Y,
          text = '5 B',
          id = 'CH07_5B',
          tooltip = TP.CH07_5B,
          midi_mapping = MR.CH07_5B,
          height = 24,
          width = 68,
          notifier = function()amic_CH07_5B() end
        },
        --- ---
        vb:button {
          color = CR.ROW07_Y,
          text = '6 B',
          id = 'CH07_6B',
          tooltip = TP.CH07_6B,
          midi_mapping = MR.CH07_6B,
          height = 24,
          width = 68,
          notifier = function()amic_CH07_6B() end
        },
        --- ---
        vb:button {
          color = CR.ROW07_Y,
          text = '7 B',
          id = 'CH07_7B',
          tooltip = TP.CH07_7B,
          midi_mapping = MR.CH07_7B,
          height = 24,
          width = 68,
          notifier = function()amic_CH07_7B() end
        },
        --- ---
        vb:button {
          color = CR.ROW07_Y,
          text = '8 B',
          id = 'CH07_8B',
          tooltip = TP.CH07_8B,
          midi_mapping = MR.CH07_8B,
          height = 24,
          width = 68,
          notifier = function()amic_CH07_8B() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW07_Z,
          text = '9 M',
          id = 'CH07_9M',
          tooltip = TP.CH07_9M,
          midi_mapping = MR.CH07_9M,
          height = 24,
          width = 68,
          notifier = function()amic_CH07_9M() end
        },
        --- ---
        vb:horizontal_aligner {
          margin = 3,
          width = 58,
          vb:text { text = ' Ch07 '},
          checkbox_amic_ch07
        }
      },
      -- -- --
      vb:column {
        id ='cbox_amic_ch07_f',
        visible = false,
      },  
      vb:column {
        id = 'cbox_amic_ch07_t',
        visible = false,
        width = 640,
        vb:horizontal_aligner { height = 2 },
        vb:horizontal_aligner {
          vb:column { width = 4},
          vb:column {
            vb:button {
              active = false,
              color = CR.ROW07_X,
              height = 60,
              width = 8,
            }
          },
          vb:column { width = 320, txt_ch07A },
          vb:vertical_aligner {
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW07_Y,
                height = 58,
                width = 8,
              }
            },
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW07_Z,
                height = 18,
                width = 8,
              }
            }
          },
          vb:column { width = 320, txt_ch07B }
        },
        vb:horizontal_aligner { height = 8 },
      }
    },
    --- ---
    --A CH08
    --- ---
    vb:column {
      id = 'cbox_amic_08_f',
      visible = false,
    },  
    vb:column {
      id = 'cbox_amic_08_t',
      visible = false,
      vb:horizontal_aligner {
        --- ---
        vb:button {
          color = CR.ROW08_X,
          text = '1 A',
          id = 'CH08_1A',
          tooltip = TP.CH08_1A,
          midi_mapping = MR.CH08_1A,
          height = 24,
          width = 68,
          notifier = function()amic_CH08_1A() end
        },
        --- ---
        vb:button {
          color = CR.ROW08_X,
          text = '2 A',
          id = 'CH08_2A',
          tooltip = TP.CH08_2A,
          midi_mapping = MR.CH08_2A,
          height = 24,
          width = 68,
          notifier = function()amic_CH08_2A() end
        },
        --- ---
        vb:button {
          color = CR.ROW08_X,
          text = '3 A',
          id = 'CH08_3A',
          tooltip = TP.CH08_3A,
          midi_mapping = MR.CH08_3A,
          height = 24,
          width = 68,
          notifier = function()amic_CH08_3A() end
        },
        --- ---
        vb:button {
          color = CR.ROW08_X,
          text = '4 A',
          id = 'CH08_4A',
          tooltip = TP.CH08_4A,
          midi_mapping = MR.CH08_4A,
          height = 24,
          width = 68,
          notifier = function()amic_CH08_4A() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW08_Y,
          text = '5 B',
          id = 'CH08_5B',
          tooltip = TP.CH08_5B,
          midi_mapping = MR.CH08_5B,
          height = 24,
          width = 68,
          notifier = function()amic_CH08_5B() end
        },
        --- ---
        vb:button {
          color = CR.ROW08_Y,
          text = '6 B',
          id = 'CH08_6B',
          tooltip = TP.CH08_6B,
          midi_mapping = MR.CH08_6B,
          height = 24,
          width = 68,
          notifier = function()amic_CH08_6B() end
        },
        --- ---
        vb:button {
          color = CR.ROW08_Y,
          text = '7 B',
          id = 'CH08_7B',
          tooltip = TP.CH08_7B,
          midi_mapping = MR.CH08_7B,
          height = 24,
          width = 68,
          notifier = function()amic_CH08_7B() end
        },
        --- ---
        vb:button {
          color = CR.ROW08_Y,
          text = '8 B',
          id = 'CH08_8B',
          tooltip = TP.CH08_8B,
          midi_mapping = MR.CH08_8B,
          height = 24,
          width = 68,
          notifier = function()amic_CH08_8B() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW08_Z,
          text = '9 M',
          id = 'CH08_9M',
          tooltip = TP.CH08_9M,
          midi_mapping = MR.CH08_9M,
          height = 24,
          width = 68,
          notifier = function()amic_CH08_9M() end
        },
        --- ---
        vb:horizontal_aligner {
          margin = 3,
          width = 58,
          vb:text { text = ' Ch08 '},
          checkbox_amic_ch08
        }
      },
      -- -- --
      vb:column {
        id ='cbox_amic_ch08_f',
        visible = false,
      },  
      vb:column {
        id = 'cbox_amic_ch08_t',
        visible = false,
        width = 640,
        vb:horizontal_aligner { height = 2 },
        vb:horizontal_aligner {
          vb:column { width = 4},
          vb:column {
            vb:button {
              active = false,
              color = CR.ROW08_X,
              height = 60,
              width = 8,
            }
          },
          vb:column { width = 320, txt_ch08A },
          vb:vertical_aligner {
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW08_Y,
                height = 58,
                width = 8,
              }
            },
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW08_Z,
                height = 18,
                width = 8,
              }
            }
          },
          vb:column { width = 320, txt_ch08B }
        },
        vb:horizontal_aligner { height = 8 },
      }
    }
  },
------------------------------------------------------------------------------- SWITH CHANNEL GROUP 09-16
  vb:column {
    id = 'abtab_f',
    visible = false,
    vb:horizontal_aligner { height = 4 },
    vb:horizontal_aligner {
      vb:column {
        width = 368,
        vb:horizontal_aligner {
          mode = 'center',
          vb:text { text = 'Channel Group 09-16' },
        }
      },
      vb:column {
        width = 200,
        vb:horizontal_aligner {
          vb:text { text = 'Selector 09-16 ' },
          checkbox_amic_09, checkbox_amic_10, checkbox_amic_11, checkbox_amic_12,
           vb:horizontal_aligner { width = 4 },
           checkbox_amic_13, checkbox_amic_14, checkbox_amic_15, checkbox_amic_16
         }
       }
    },
    vb:horizontal_aligner { height = 4 },
------------------------------------------------------------------------------- 
    --- ---
    --A CH09
    --- ---
    vb:column {
      id = 'cbox_amic_09_f',
      visible = false,
    },  
    vb:column {
      id = 'cbox_amic_09_t',
      visible = true,
      vb:horizontal_aligner {
        --- ---
        vb:button {
          color = CR.ROW09_X,
          text = '1 A',
          id = 'CH09_1A',
          tooltip = TP.CH09_1A,
          midi_mapping = MR.CH09_1A,
          height = 24,
          width = 68,
          notifier = function()amic_CH09_1A() end
        },
        --- ---
        vb:button {
          color = CR.ROW09_X,
          text = '2 A',
          id = 'CH09_2A',
          tooltip = TP.CH09_2A,
          midi_mapping = MR.CH09_2A,
          height = 24,
          width = 68,
          notifier = function()amic_CH09_2A() end
        },
        --- ---
        vb:button {
          color = CR.ROW09_X,
          text = '3 A',
          id = 'CH09_3A',
          tooltip = TP.CH09_3A,
          midi_mapping = MR.CH09_3A,
          height = 24,
          width = 68,
          notifier = function()amic_CH09_3A() end
        },
        --- ---
        vb:button {
          color = CR.ROW09_X,
          text = '4 A',
          id = 'CH09_4A',
          tooltip = TP.CH09_4A,
          midi_mapping = MR.CH09_4A,
          height = 24,
          width = 68,
          notifier = function()amic_CH09_4A() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW09_Y,
          text = '5 B',
          id = 'CH09_5B',
          tooltip = TP.CH09_5B,
          midi_mapping = MR.CH09_5B,
          height = 24,
          width = 68,
          notifier = function()amic_CH09_5B() end
        },
        --- ---
        vb:button {
          color = CR.ROW09_Y,
          text = '6 B',
          id = 'CH09_6B',
          tooltip = TP.CH09_6B,
          midi_mapping = MR.CH09_6B,
          height = 24,
          width = 68,
          notifier = function()amic_CH09_6B() end
        },
        --- ---
        vb:button {
          color = CR.ROW09_Y,
          text = '7 B',
          id = 'CH09_7B',
          tooltip = TP.CH09_7B,
          midi_mapping = MR.CH09_7B,
          height = 24,
          width = 68,
          notifier = function()amic_CH09_7B() end
        },
        --- ---
        vb:button {
          color = CR.ROW09_Y,
          text = '8 B',
          id = 'CH09_8B',
          tooltip = TP.CH09_8B,
          midi_mapping = MR.CH09_8B,
          height = 24,
          width = 68,
          notifier = function()amic_CH09_8B() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW09_Z,
          text = '9 M',
          id = 'CH09_9M',
          tooltip = TP.CH09_9M,
          midi_mapping = MR.CH09_9M,
          height = 24,
          width = 68,
          notifier = function()amic_CH09_9M() end
        },
        --- ---
        vb:horizontal_aligner {
          margin = 3,
          width = 58,
          vb:text { text = ' Ch09 '},
          checkbox_amic_ch09
        }
      },
      -- -- --
      vb:column {
        id ='cbox_amic_ch09_f',
        visible = false,
      }, 
      vb:column {
        id = 'cbox_amic_ch09_t',
        visible = false,
        width = 640,
        vb:horizontal_aligner { height = 2 },
        vb:horizontal_aligner {
          vb:column { width = 4},
          vb:column {
            vb:button {
              active = false,
              color = CR.ROW09_X,
              height = 60,
              width = 8,
            }
          },
          vb:column { width = 320, txt_ch09A },
          vb:vertical_aligner {
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW09_Y,
                height = 58,
                width = 8,
              }
            },
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW09_Z,
                height = 18,
                width = 8,
              }
            }
          },
          vb:column { width = 320, txt_ch09B }
        },
        vb:horizontal_aligner { height = 8 },
      }
    },
    --- ---
    --A CH10
    --- ---
    vb:column {
      id = 'cbox_amic_10_f',
      visible = false,
    },  
    vb:column {
      id = 'cbox_amic_10_t',
      visible = true,
      vb:horizontal_aligner {
        --- ---
        vb:button {
          color = CR.ROW10_X,
          text = '1 A',
          id = 'CH10_1A',
          tooltip = TP.CH10_1A,
          midi_mapping = MR.CH10_1A,
          height = 24,
          width = 68,
          notifier = function()amic_CH02_1A() end
        },
        --- ---
        vb:button {
          color = CR.ROW10_X,
          text = '2 A',
          id = 'CH10_2A',
          tooltip = TP.CH10_2A,
          midi_mapping = MR.CH10_2A,
          height = 24,
          width = 68,
          notifier = function()amic_CH10_2A() end
        },
        --- ---
        vb:button {
          color = CR.ROW10_X,
          text = '3 A',
          id = 'CH10_3A',
          tooltip = TP.CH10_3A,
          midi_mapping = MR.CH10_3A,
          height = 24,
          width = 68,
          notifier = function()amic_CH10_3A() end
        },
        --- ---
        vb:button {
          color = CR.ROW10_X,
          text = '4 A',
          id = 'CH10_4A',
          tooltip = TP.CH10_4A,
          midi_mapping = MR.CH10_4A,
          height = 24,
          width = 68,
          notifier = function()amic_CH10_4A() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW10_Y,
          text = '5 B',
          id = 'CH10_5B',
          tooltip = TP.CH10_5B,
          midi_mapping = MR.CH10_5B,
          height = 24,
          width = 68,
          notifier = function()amic_CH10_5B() end
        },
        --- ---
        vb:button {
          color = CR.ROW10_Y,
          text = '6 B',
          id = 'CH10_6B',
          tooltip = TP.CH10_6B,
          midi_mapping = MR.CH10_6B,
          height = 24,
          width = 68,
          notifier = function()amic_CH10_6B() end
        },
        --- ---
        vb:button {
          color = CR.ROW10_Y,
          text = '7 B',
          id = 'CH10_7B',
          tooltip = TP.CH10_7B,
          midi_mapping = MR.CH10_7B,
          height = 24,
          width = 68,
          notifier = function()amic_CH10_7B() end
        },
        --- ---
        vb:button {
          color = CR.ROW10_Y,
          text = '8 B',
          id = 'CH10_8B',
          tooltip = TP.CH10_8B,
          midi_mapping = MR.CH10_8B,
          height = 24,
          width = 68,
          notifier = function()amic_CH10_8B() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW10_Z,
          text = '9 M',
          id = 'CH10_9M',
          tooltip = TP.CH10_9M,
          midi_mapping = MR.CH10_9M,
          height = 24,
          width = 68,
          notifier = function()amic_CH10_9M() end
        },
        --- ---
        vb:horizontal_aligner {
          margin = 3,
          width = 58,
          vb:text { text = ' Ch10 '},
          checkbox_amic_ch10
        }
      },
      -- -- --
      vb:column {
        id ='cbox_amic_ch10_f',
        visible = false,
      },  
      vb:column {
        id = 'cbox_amic_ch10_t',
        visible = false,
        width = 640,
        vb:horizontal_aligner { height = 2 },
        vb:horizontal_aligner {
          vb:column { width = 4},
          vb:column {
            vb:button {
              active = false,
              color = CR.ROW10_X,
              height = 60,
              width = 8,
            }
          },
          vb:column { width = 320, txt_ch10A },
          vb:vertical_aligner {
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW10_Y,
                height = 58,
                width = 8,
              }
            },
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW10_Z,
                height = 18,
                width = 8,
              }
            }
          },
          vb:column { width = 320, txt_ch10B }
        },
        vb:horizontal_aligner { height = 8 },
      }
    },
    --- ---
    --A CH11
    --- ---  
    vb:column {
      id = 'cbox_amic_11_f',
      visible = false,
    },  
    vb:column {
      id = 'cbox_amic_11_t',
      visible = true,
      vb:horizontal_aligner {
        --- ---
        vb:button {
          color = CR.ROW11_X,
          text = '1 A',
          id = 'CH11_1A',
          tooltip = TP.CH11_1A,
          midi_mapping = MR.CH11_1A,
          height = 24,
          width = 68,
          notifier = function()amic_CH11_1A() end
        },
        --- ---
        vb:button {
          color = CR.ROW11_X,
          text = '2 A',
          id = 'CH11_2A',
          tooltip = TP.CH11_2A,
          midi_mapping = MR.CH11_2A,
          height = 24,
          width = 68,
          notifier = function()amic_CH11_2A() end
        },
        --- ---
        vb:button {
          color = CR.ROW11_X,
          text = '3 A',
          id = 'CH11_3A',
          tooltip = TP.CH11_3A,
          midi_mapping = MR.CH11_3A,
          height = 24,
          width = 68,
          notifier = function()amic_CH11_3A() end
        },
        --- ---
        vb:button {
          color = CR.ROW11_X,
          text = '4 A',
          id = 'CH11_4A',
          tooltip = TP.CH11_4A,
          midi_mapping = MR.CH11_4A,
          height = 24,
          width = 68,
          notifier = function()amic_CH11_4A() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW11_Y,
          text = '5 B',
          id = 'CH11_5B',
          tooltip = TP.CH11_5B,
          midi_mapping = MR.CH11_5B,
          height = 24,
          width = 68,
          notifier = function()amic_CH11_5B() end
        },
        --- ---
        vb:button {
          color = CR.ROW11_Y,
          text = '6 B',
          id = 'CH11_6B',
          tooltip = TP.CH11_6B,
          midi_mapping = MR.CH11_6B,
          height = 24,
          width = 68,
          notifier = function()amic_CH11_6B() end
        },
        --- ---
        vb:button {
          color = CR.ROW11_Y,
          text = '7 B',
          id = 'CH11_7B',
          tooltip = TP.CH11_7B,
          midi_mapping = MR.CH11_7B,
          height = 24,
          width = 68,
          notifier = function()amic_CH11_7B() end
        },
        --- ---
        vb:button {
          color = CR.ROW11_Y,
          text = '8 B',
          id = 'CH11_8B',
          tooltip = TP.CH11_8B,
          midi_mapping = MR.CH11_8B,
          height = 24,
          width = 68,
          notifier = function()amic_CH11_8B() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW11_Z,
          text = '9 M',
          id = 'CH11_9M',
          tooltip = TP.CH11_9M,
          midi_mapping = MR.CH11_9M,
          height = 24,
          width = 68,
          notifier = function()amic_CH11_9M() end
        },
        --- ---
        vb:horizontal_aligner {
          margin = 3,
          width = 58,
          vb:text { text = ' Ch11 '},
          checkbox_amic_ch11
        }
      },
      -- -- --
      vb:column {
        id ='cbox_amic_ch11_f',
        visible = false,
      },  
      vb:column {
        id = 'cbox_amic_ch11_t',
        visible = false,
        width = 640,
        vb:horizontal_aligner { height = 2 },
        vb:horizontal_aligner {
          vb:column { width = 4},
          vb:column {
            vb:button {
              active = false,
              color = CR.ROW11_X,
              height = 60,
              width = 8,
            }
          },
          vb:column { width = 320, txt_ch11A },
          vb:vertical_aligner {
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW11_Y,
                height = 58,
                width = 8,
              }
            },
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW11_Z,
                height = 18,
                width = 8,
              }
            }
          },
          vb:column { width = 320, txt_ch11B }
        },
        vb:horizontal_aligner { height = 8 },
      }
    },
    --- ---
    --A CH12
    --- ---
    vb:column {
      id = 'cbox_amic_12_f',
      visible = false,
    },  
    vb:column {
      id = 'cbox_amic_12_t',
      visible = true,
      vb:horizontal_aligner {
        --- ---
        vb:button {
          color = CR.ROW12_X,
          text = '1 A',
          id = 'CH12_1A',
          tooltip = TP.CH12_1A,
          midi_mapping = MR.CH12_1A,
          height = 24,
          width = 68,
          notifier = function()amic_CH12_1A() end
        },
        --- ---
        vb:button {
          color = CR.ROW12_X,
          text = '2 A',
          id = 'CH12_2A',
          tooltip = TP.CH12_2A,
          midi_mapping = MR.CH12_2A,
          height = 24,
          width = 68,
          notifier = function()amic_CH12_2A() end
        },
        --- ---
        vb:button {
          color = CR.ROW12_X,
          text = '3 A',
          id = 'CH12_3A',
          tooltip = TP.CH12_3A,
          midi_mapping = MR.CH12_3A,
          height = 24,
          width = 68,
          notifier = function()amic_CH12_3A() end
        },
        --- ---
        vb:button {
          color = CR.ROW12_X,
          text = '4 A',
          id = 'CH12_4A',
          tooltip = TP.CH12_4A,
          midi_mapping = MR.CH12_4A,
          height = 24,
          width = 68,
          notifier = function()amic_CH12_4A() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW12_Y,
          text = '5 B',
          id = 'CH12_5B',
          tooltip = TP.CH12_5B,
          midi_mapping = MR.CH12_5B,
          height = 24,
          width = 68,
          notifier = function()amic_CH12_5B() end
        },
        --- ---
        vb:button {
          color = CR.ROW12_Y,
          text = '6 B',
          id = 'CH12_6B',
          tooltip = TP.CH12_6B,
          midi_mapping = MR.CH12_6B,
          height = 24,
          width = 68,
          notifier = function()amic_CH12_6B() end
        },
        --- ---
        vb:button {
          color = CR.ROW12_Y,
          text = '7 B',
          id = 'CH12_7B',
          tooltip = TP.CH12_7B,
          midi_mapping = MR.CH12_7B,
          height = 24,
          width = 68,
          notifier = function()amic_CH12_7B() end
        },
        --- ---
        vb:button {
          color = CR.ROW12_Y,
          text = '8 B',
          id = 'CH12_8B',
          tooltip = TP.CH12_8B,
          midi_mapping = MR.CH12_8B,
          height = 24,
          width = 68,
          notifier = function()amic_CH12_8B() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW12_Z,
          text = '9 M',
          id = 'CH12_9M',
          tooltip = TP.CH12_9M,
          midi_mapping = MR.CH12_9M,
          height = 24,
          width = 68,
          notifier = function()amic_CH12_9M() end
        },
        --- ---
        vb:horizontal_aligner {
          margin = 3,
          width = 58,
          vb:text { text = ' Ch12 '},
          checkbox_amic_ch12
        }
      },
      -- -- --
      vb:column {
        id ='cbox_amic_ch12_f',
        visible = false,
      },  
      vb:column {
        id = 'cbox_amic_ch12_t',
        visible = false,
        width = 640,
        vb:horizontal_aligner { height = 2 },
        vb:horizontal_aligner {
          vb:column { width = 4},
          vb:column {
            vb:button {
              active = false,
              color = CR.ROW12_X,
              height = 60,
              width = 8,
            }
          },
          vb:column { width = 320, txt_ch12A },
          vb:vertical_aligner {
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW12_Y,
                height = 58,
                width = 8,
              }
            },
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW12_Z,
                height = 18,
                width = 8,
              }
            }
          },
          vb:column { width = 320, txt_ch12B }
        },
        vb:horizontal_aligner { height = 8 },
      }
    },
    --- ---
    --A CH13
    --- ---
    vb:column {
      id = 'cbox_amic_13_f',
      visible = false,
    },  
    vb:column {
      id = 'cbox_amic_13_t',
      visible = false,
      vb:horizontal_aligner {
        --- ---
        vb:button {
          color = CR.ROW13_X,
          text = '1 A',
          id = 'CH13_1A',
          tooltip = TP.CH13_1A,
          midi_mapping = MR.CH13_1A,
          height = 24,
          width = 68,
          notifier = function()amic_CH13_1A() end
        },
        --- ---
        vb:button {
          color = CR.ROW13_X,
          text = '2 A',
          id = 'CH13_2A',
          tooltip = TP.CH13_2A,
          midi_mapping = MR.CH13_2A,
          height = 24,
          width = 68,
          notifier = function()amic_CH13_2A() end
        },
        --- ---
        vb:button {
          color = CR.ROW13_X,
          text = '3 A',
          id = 'CH13_3A',
          tooltip = TP.CH13_3A,
          midi_mapping = MR.CH13_3A,
          height = 24,
          width = 68,
          notifier = function()amic_CH13_3A() end
        },
        --- ---
        vb:button {
          color = CR.ROW13_X,
          text = '4 A',
          id = 'CH13_4A',
          tooltip = TP.CH13_4A,
          midi_mapping = MR.CH13_4A,
          height = 24,
          width = 68,
          notifier = function()amic_CH13_4A() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW13_Y,
          text = '5 B',
          id = 'CH13_5B',
          tooltip = TP.CH13_5B,
          midi_mapping = MR.CH13_5B,
          height = 24,
          width = 68,
          notifier = function()amic_CH13_5B() end
        },
        --- ---
        vb:button {
          color = CR.ROW13_Y,
          text = '6 B',
          id = 'CH13_6B',
          tooltip = TP.CH13_6B,
          midi_mapping = MR.CH13_6B,
          height = 24,
          width = 68,
          notifier = function()amic_CH13_6B() end
        },
        --- ---
        vb:button {
          color = CR.ROW13_Y,
          text = '7 B',
          id = 'CH13_7B',
          tooltip = TP.CH13_7B,
          midi_mapping = MR.CH13_7B,
          height = 24,
          width = 68,
          notifier = function()amic_CH13_7B() end
        },
        --- ---
        vb:button {
          color = CR.ROW13_Y,
          text = '8 B',
          id = 'CH13_8B',
          tooltip = TP.CH13_8B,
          midi_mapping = MR.CH13_8B,
          height = 24,
          width = 68,
          notifier = function()amic_CH13_8B() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW13_Z,
          text = '9 M',
          id = 'CH13_9M',
          tooltip = TP.CH13_9M,
          midi_mapping = MR.CH13_9M,
          height = 24,
          width = 68,
          notifier = function()amic_CH13_9M() end
        },
        --- ---
        vb:horizontal_aligner {
          margin = 3,
          width = 58,
          vb:text { text = ' Ch13 '},
          checkbox_amic_ch13
        }
      },
      -- -- --
      vb:column {
        id ='cbox_amic_ch13_f',
        visible = false,
      },  
      vb:column {
        id = 'cbox_amic_ch13_t',
        visible = false,
        width = 640,
        vb:horizontal_aligner { height = 2 },
        vb:horizontal_aligner {
          vb:column { width = 4},
          vb:column {
            vb:button {
              active = false,
              color = CR.ROW13_X,
              height = 60,
              width = 8,
            }
          },
          vb:column { width = 320, txt_ch13A },
          vb:vertical_aligner {
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW13_Y,
                height = 58,
                width = 8,
              }
            },
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW13_Z,
                height = 18,
                width = 8,
              }
            }
          },
          vb:column { width = 320, txt_ch13B }
        },
        vb:horizontal_aligner { height = 8 },
      }
    },
    --- ---
    --A CH14
    --- ---
    vb:column {
      id = 'cbox_amic_14_f',
      visible = false,
    },  
    vb:column {
      id = 'cbox_amic_14_t',
      visible = false,
      vb:horizontal_aligner {
        --- ---
        vb:button {
          color = CR.ROW14_X,
          text = '1 A',
          id = 'CH14_1A',
          tooltip = TP.CH14_1A,
          midi_mapping = MR.CH14_1A,
          height = 24,
          width = 68,
          notifier = function()amic_CH14_1A() end
        },
        --- ---
        vb:button {
          color = CR.ROW14_X,
          text = '2 A',
          id = 'CH14_2A',
          tooltip = TP.CH14_2A,
          midi_mapping = MR.CH14_2A,
          height = 24,
          width = 68,
          notifier = function()amic_CH14_2A() end
        },
        --- ---
        vb:button {
          color = CR.ROW14_X,
          text = '3 A',
          id = 'CH14_3A',
          tooltip = TP.CH14_3A,
          midi_mapping = MR.CH14_3A,
          height = 24,
          width = 68,
          notifier = function()amic_CH14_3A() end
        },
        --- ---
        vb:button {
          color = CR.ROW14_X,
          text = '4 A',
          id = 'CH14_4A',
          tooltip = TP.CH14_4A,
          midi_mapping = MR.CH14_4A,
          height = 24,
          width = 68,
          notifier = function()amic_CH14_4A() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW14_Y,
          text = '5 B',
          id = 'CH14_5B',
          tooltip = TP.CH14_5B,
          midi_mapping = MR.CH14_5B,
          height = 24,
          width = 68,
          notifier = function()amic_CH14_5B() end
        },
        --- ---
        vb:button {
          color = CR.ROW14_Y,
          text = '6 B',
          id = 'CH14_6B',
          tooltip = TP.CH14_6B,
          midi_mapping = MR.CH14_6B,
          height = 24,
          width = 68,
          notifier = function()amic_CH14_6B() end
        },
        --- ---
        vb:button {
          color = CR.ROW14_Y,
          text = '7 B',
          id = 'CH14_7B',
          tooltip = TP.CH14_7B,
          midi_mapping = MR.CH14_7B,
          height = 24,
          width = 68,
          notifier = function()amic_CH14_7B() end
        },
        --- ---
        vb:button {
          color = CR.ROW14_Y,
          text = '8 B',
          id = 'CH14_8B',
          tooltip = TP.CH14_8B,
          midi_mapping = MR.CH14_8B,
          height = 24,
          width = 68,
          notifier = function()amic_CH14_8B() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW14_Z,
          text = '9 M',
          id = 'CH14_9M',
          tooltip = TP.CH14_9M,
          midi_mapping = MR.CH14_9M,
          height = 24,
          width = 68,
          notifier = function()amic_CH14_9M() end
        },
        --- ---
        vb:horizontal_aligner {
          margin = 3,
          width = 58,
          vb:text { text = ' Ch14 '},
          checkbox_amic_ch14
        }
      },
      -- -- --
      vb:column {
        id ='cbox_amic_ch14_f',
        visible = false,
      },  
      vb:column {
        id = 'cbox_amic_ch14_t',
        visible = false,
        width = 640,
        vb:horizontal_aligner { height = 2 },
        vb:horizontal_aligner {
          vb:column { width = 4},
          vb:column {
            vb:button {
              active = false,
              color = CR.ROW14_X,
              height = 60,
              width = 8,
            }
          },
          vb:column { width = 320, txt_ch14A },
          vb:vertical_aligner {
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW14_Y,
                height = 58,
                width = 8,
              }
            },
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW14_Z,
                height = 18,
                width = 8,
              }
            }
          },
          vb:column { width = 320, txt_ch14B }
        },
        vb:horizontal_aligner { height = 8 },
      }
    },
    --- ---
    --A CH15
    --- ---
    vb:column {
      id = 'cbox_amic_15_f',
      visible = false,
    },  
    vb:column {
      id = 'cbox_amic_15_t',
      visible = false,
      vb:horizontal_aligner {
        --- ---
        vb:button {
          color = CR.ROW15_X,
          text = '1 A',
          id = 'CH15_1A',
          tooltip = TP.CH15_1A,
          midi_mapping = MR.CH15_1A,
          height = 24,
          width = 68,
          notifier = function()amic_CH15_1A() end
        },
        --- ---
        vb:button {
          color = CR.ROW15_X,
          text = '2 A',
          id = 'CH15_2A',
          tooltip = TP.CH15_2A,
          midi_mapping = MR.CH15_2A,
          height = 24,
          width = 68,
          notifier = function()amic_CH15_2A() end
        },
        --- ---
        vb:button {
          color = CR.ROW15_X,
          text = '3 A',
          id = 'CH15_3A',
          tooltip = TP.CH15_3A,
          midi_mapping = MR.CH15_3A,
          height = 24,
          width = 68,
          notifier = function()amic_CH15_3A() end
        },
        --- ---
        vb:button {
          color = CR.ROW15_X,
          text = '4 A',
          id = 'CH15_4A',
          tooltip = TP.CH15_4A,
          midi_mapping = MR.CH15_4A,
          height = 24,
          width = 68,
          notifier = function()amic_CH15_4A() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW15_Y,
          text = '5 B',
          id = 'CH15_5B',
          tooltip = TP.CH15_5B,
          midi_mapping = MR.CH15_5B,
          height = 24,
          width = 68,
          notifier = function()amic_CH15_5B() end
        },
        --- ---
        vb:button {
          color = CR.ROW15_Y,
          text = '6 B',
          id = 'CH15_6B',
          tooltip = TP.CH15_6B,
          midi_mapping = MR.CH15_6B,
          height = 24,
          width = 68,
          notifier = function()amic_CH15_6B() end
        },
        --- ---
        vb:button {
          color = CR.ROW15_Y,
          text = '7 B',
          id = 'CH15_7B',
          tooltip = TP.CH15_7B,
          midi_mapping = MR.CH15_7B,
          height = 24,
          width = 68,
          notifier = function()amic_CH15_7B() end
        },
        --- ---
        vb:button {
          color = CR.ROW15_Y,
          text = '8 B',
          id = 'CH15_8B',
          tooltip = TP.CH15_8B,
          midi_mapping = MR.CH15_8B,
          height = 24,
          width = 68,
          notifier = function()amic_CH15_8B() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW15_Z,
          text = '9 M',
          id = 'CH15_9M',
          tooltip = TP.CH15_9M,
          midi_mapping = MR.CH15_9M,
          height = 24,
          width = 68,
          notifier = function()amic_CH15_9M() end
        },
        --- ---
        vb:horizontal_aligner {
          margin = 3,
          width = 58,
          vb:text { text = ' Ch15 '},
          checkbox_amic_ch15
        }
      },
      -- -- --
      vb:column {
        id ='cbox_amic_ch15_f',
        visible = false,
      },  
      vb:column {
        id = 'cbox_amic_ch15_t',
        visible = false,
        width = 640,
        vb:horizontal_aligner { height = 2 },
        vb:horizontal_aligner {
          vb:column { width = 4},
          vb:column {
            vb:button {
              active = false,
              color = CR.ROW15_X,
              height = 60,
              width = 8,
            }
          },
          vb:column { width = 320, txt_ch15A },
          vb:vertical_aligner {
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW15_Y,
                height = 58,
                width = 8,
              }
            },
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW15_Z,
                height = 18,
                width = 8,
              }
            }
          },
          vb:column { width = 320, txt_ch15B }
        },
        vb:horizontal_aligner { height = 8 },
      }
    },
    --- ---
    --A CH16
    --- ---
    vb:column {
      id = 'cbox_amic_16_f',
      visible = false,
    },  
    vb:column {
      id = 'cbox_amic_16_t',
      visible = false,
      vb:horizontal_aligner {
        --- ---
        vb:button {
          color = CR.ROW16_X,
          text = '1 A',
          id = 'CH16_1A',
          tooltip = TP.CH16_1A,
          midi_mapping = MR.CH16_1A,
          height = 24,
          width = 68,
          notifier = function()amic_CH16_1A() end
        },
        --- ---
        vb:button {
          color = CR.ROW16_X,
          text = '2 A',
          id = 'CH16_2A',
          tooltip = TP.CH16_2A,
          midi_mapping = MR.CH16_2A,
          height = 24,
          width = 68,
          notifier = function()amic_CH16_2A() end
        },
        --- ---
        vb:button {
          color = CR.ROW16_X,
          text = '3 A',
          id = 'CH16_3A',
          tooltip = TP.CH16_3A,
          midi_mapping = MR.CH16_3A,
          height = 24,
          width = 68,
          notifier = function()amic_CH16_3A() end
        },
        --- ---
        vb:button {
          color = CR.ROW16_X,
          text = '4 A',
          id = 'CH16_4A',
          tooltip = TP.CH16_4A,
          midi_mapping = MR.CH16_4A,
          height = 24,
          width = 68,
          notifier = function()amic_CH16_4A() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW16_Y,
          text = '5 B',
          id = 'CH16_5B',
          tooltip = TP.CH16_5B,
          midi_mapping = MR.CH16_5B,
          height = 24,
          width = 68,
          notifier = function()amic_CH16_5B() end
        },
        --- ---
        vb:button {
          color = CR.ROW16_Y,
          text = '6 B',
          id = 'CH16_6B',
          tooltip = TP.CH16_6B,
          midi_mapping = MR.CH16_6B,
          height = 24,
          width = 68,
          notifier = function()amic_CH16_6B() end
        },
        --- ---
        vb:button {
          color = CR.ROW16_Y,
          text = '7 B',
          id = 'CH16_7B',
          tooltip = TP.CH16_7B,
          midi_mapping = MR.CH16_7B,
          height = 24,
          width = 68,
          notifier = function()amic_CH16_7B() end
        },
        --- ---
        vb:button {
          color = CR.ROW16_Y,
          text = '8 B',
          id = 'CH16_8B',
          tooltip = TP.CH16_8B,
          midi_mapping = MR.CH16_8B,
          height = 24,
          width = 68,
          notifier = function()amic_CH16_8B() end
        },
        --- ---
        vb:horizontal_aligner { width = 4 },
        --- ---
        vb:button {
          color = CR.ROW16_Z,
          text = '9 M',
          id = 'CH16_9M',
          tooltip = TP.CH16_9M,
          midi_mapping = MR.CH16_9M,
          height = 24,
          width = 68,
          notifier = function()amic_CH16_9M() end
        },
        --- ---
        vb:horizontal_aligner {
          margin = 3,
          width = 58,
          vb:text { text = ' Ch16 '},
          checkbox_amic_ch16
        }
      },
      -- -- --
      vb:column {
        id ='cbox_amic_ch16_f',
        visible = false,
      },  
      vb:column {
        id = 'cbox_amic_ch16_t',
        visible = false,
        width = 640,
        vb:horizontal_aligner { height = 2 },
        vb:horizontal_aligner {
          vb:column { width = 4},
          vb:column {
            vb:button {
              active = false,
              color = CR.ROW16_X,
              height = 60,
              width = 8,
            }
          },
          vb:column { width = 320, txt_ch16A },
          vb:vertical_aligner {
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW16_Y,
                height = 58,
                width = 8,
              }
            },
            vb:column {
              vb:button {
                active = false,
                color = CR.ROW16_Z,
                height = 18,
                width = 8,
              }
            }
          },
          vb:column { width = 320, txt_ch16B }
        },
        vb:horizontal_aligner { height = 8 },
      }
    }
  },
------------------------------------------------------------------------------- +INFO
  --- ---
  --- ---
  vb:column {
    id ='cbox_amic_info_f',
    visible = false,
  },  
  vb:column {
    id = 'cbox_amic_info_t',
    visible = false,
    width = 640,
    vb:horizontal_aligner { height = 4 },
    vb:horizontal_aligner {
      mode = 'right',
      txt_info
    }
  }  
}
------------------------- start the things
show_abtab(1) -- 1  2









--------------------------------------------------------------------------------
-- MIDI/KEY MAPPING
--------------------------------------------------------------------------------
--- --- ---
-- A Ch01
--- --- ---
renoise.tool():add_midi_mapping {
  name = MR.CH01_1A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH01_1A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH01_2A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH01_2A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH01_3A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH01_3A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH01_4A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH01_4A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH01_5B,
  invoke = function(message)
    if message:is_switch() then
      if message.boolean_value then
        vb.views.CH01_5B.color = CR.ROW01_F
        amic_CH01_5B()
      else
        vb.views.CH01_5B.color = CR.ROW01_Y
      end
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH01_6B,
  invoke = function(message)
    if message:is_switch() then
      if message.boolean_value then
        vb.views.CH01_6B.color = CR.ROW01_F
        --print("On!!")  --This executed when switch is pressed
      else
        vb.views.CH01_6B.color = CR.ROW01_Y
        amic_CH01_6B()
        --print("Off!!") --This executed when switch is released
      end
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH01_7B,
  invoke = function(message)
    if message:is_switch() then
      if message.boolean_value then
        vb.views.CH01_7B.color = CR.ROW01_F
      else
        vb.views.CH01_7B.color = CR.ROW01_Y
        amic_CH01_7B()
      end
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH01_8B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH01_8B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH01_9M,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH01_9M()
    end
  end
}
--- --- ---
-- A Ch02
--- --- ---
renoise.tool():add_midi_mapping {
  name = MR.CH02_1A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH02_1A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH02_2A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH02_2A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH02_3A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH02_3A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH02_4A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH02_4A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH02_5B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH02_5B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH02_6B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH02_6B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH02_7B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH02_7B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH02_8B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH02_8B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH02_9M,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH02_9M()
    end
  end
}
--- --- ---
-- A Ch03
--- --- ---
renoise.tool():add_midi_mapping {
  name = MR.CH03_1A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH03_1A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH03_2A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH03_2A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH03_3A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH03_3A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH03_4A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH03_4A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH03_5B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH03_5B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH03_6B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH03_6B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH03_7B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH03_7B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH03_8B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH03_8B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH03_9M,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH03_9M()
    end
  end
}
--- --- ---
-- A Ch04
--- --- ---
renoise.tool():add_midi_mapping {
  name = MR.CH04_1A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH04_1A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH04_2A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH04_2A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH04_3A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH04_3A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH04_4A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH04_4A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH04_5B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH04_5B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH04_6B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH04_6B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH04_7B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH04_7B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH04_8B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH04_8B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH04_9M,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH04_9M()
    end
  end
}
--- --- ---
-- A Ch05
--- --- ---
renoise.tool():add_midi_mapping {
  name = MR.CH05_1A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH05_1A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH05_2A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH05_2A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH05_3A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH05_3A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH05_4A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH05_4A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH05_5B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH05_5B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH05_6B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH05_6B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH05_7B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH05_7B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH05_8B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH05_8B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH05_9M,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH05_9M()
    end
  end
}
--- --- ---
-- A Ch06
--- --- ---
renoise.tool():add_midi_mapping {
  name = MR.CH06_1A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH06_1A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH06_2A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH06_2A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH06_3A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH06_3A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH06_4A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH06_4A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH06_5B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH06_5B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH06_6B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH06_6B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH06_7B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH06_7B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH06_8B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH06_8B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH06_9M,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH06_9M()
    end
  end
}
--- --- ---
-- A Ch07
--- --- ---
renoise.tool():add_midi_mapping {
  name = MR.CH07_1A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH07_1A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH07_2A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH07_2A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH07_3A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH07_3A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH07_4A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH07_4A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH07_5B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH07_5B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH07_6B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH07_6B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH07_7B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH07_7B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH07_8B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH07_8B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH07_9M,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH07_9M()
    end
  end
}
--- --- ---
-- A Ch08
--- --- ---
renoise.tool():add_midi_mapping {
  name = MR.CH08_1A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH08_1A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH08_2A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH08_2A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH08_3A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH08_3A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH08_4A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH08_4A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH08_5B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH08_5B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH08_6B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH08_6B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH08_7B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH08_7B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH08_8B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH08_8B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH08_9M,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH08_9M()
    end
  end
}


--- --- ---
-- B Ch09
--- --- ---
renoise.tool():add_midi_mapping {
  name = MR.CH09_1A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH09_1A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH09_2A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH09_2A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH09_3A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH09_3A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH09_4A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH09_4A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH09_5B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH09_5B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH09_6B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH09_6B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH09_7B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH09_7B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH09_8B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH09_8B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH09_9M,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH09_9M()
    end
  end
}
--- --- ---
-- B Ch10
--- --- ---
renoise.tool():add_midi_mapping {
  name = MR.CH10_1A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH10_1A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH10_2A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH10_2A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH10_3A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH10_3A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH10_4A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH10_4A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH10_5B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH10_5B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH10_6B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH10_6B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH10_7B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH10_7B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH10_8B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH10_8B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH10_9M,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH10_9M()
    end
  end
}
--- --- ---
-- B Ch11
--- --- ---
renoise.tool():add_midi_mapping {
  name = MR.CH11_1A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH11_1A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH11_2A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH11_2A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH11_3A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH11_3A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH11_4A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH11_4A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH11_5B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH11_5B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH11_6B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH11_6B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH11_7B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH11_7B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH11_8B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH11_8B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH11_9M,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH11_9M()
    end
  end
}
--- --- ---
-- B Ch12
--- --- ---
renoise.tool():add_midi_mapping {
  name = MR.CH12_1A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH12_1A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH12_2A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH12_2A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH12_3A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH12_3A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH12_4A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH12_4A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH12_5B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH12_5B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH12_6B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH12_6B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH12_7B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH12_7B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH12_8B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH12_8B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH12_9M,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH12_9M()
    end
  end
}
--- --- ---
-- B Ch13
--- --- ---
renoise.tool():add_midi_mapping {
  name = MR.CH13_1A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH13_1A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH13_2A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH13_2A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH13_3A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH13_3A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH13_4A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH13_4A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH13_5B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH13_5B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH13_6B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH13_6B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH13_7B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH13_7B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH13_8B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH13_8B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH13_9M,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH13_9M()
    end
  end
}
--- --- ---
-- B Ch14
--- --- ---
renoise.tool():add_midi_mapping {
  name = MR.CH14_1A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH14_1A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH14_2A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH14_2A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH14_3A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH14_3A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH14_4A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH14_4A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH14_5B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH14_5B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH14_6B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH14_6B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH14_7B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH14_7B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH14_8B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH14_8B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH14_9M,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH14_9M()
    end
  end
}
--- --- ---
-- B Ch15
--- --- ---
renoise.tool():add_midi_mapping {
  name = MR.CH15_1A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH15_1A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH15_2A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH15_2A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH15_3A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH15_3A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH15_4A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH15_4A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH15_5B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH15_5B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH15_6B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH15_6B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH15_7B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH15_7B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH15_8B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH15_8B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH15_9M,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH15_9M()
    end
  end
}
--- --- ---
-- B Ch16
--- --- ---
renoise.tool():add_midi_mapping {
  name = MR.CH16_1A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH16_1A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH16_2A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH16_2A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH16_3A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH16_3A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH16_4A,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH16_4A()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH16_5B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH16_5B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH16_6B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH16_6B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH16_7B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH16_7B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH16_8B,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH16_8B()
    end
  end
}
renoise.tool():add_midi_mapping {
  name = MR.CH16_9M,
  invoke = function(message)
    if (message:is_trigger()) then
      amic_CH16_9M()
    end
  end
}
